unit I2L3DIntrinsics;

{3D Primatives for XPL0 intrinsics}

interface

uses   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, paintpan, StdCtrls, SpinButtons, intspin,Contnrs,DSupport,Vector,I2LInterp,
  GLViewer, GLRenderer, GLFrame, GLMesh, GLLines, GL3DFigures,GLTexture;


procedure Intialize3DGraphics(Viewer: TGLViewer);

procedure Enable3DViewer;
procedure Set3DWindow;
procedure Set3DRenderMode;
procedure Add3DObject;
procedure Delete3DObject;
procedure Position3DObject;
procedure Rotate3DObject;
procedure Add3DTriangle;
procedure Add3DRectangle;
procedure Add3DLine;
procedure Update3DViewer;
procedure Set3DNormals;
procedure Clear3DData;
procedure Get3DViewerInfo;
procedure Set3DBackColor;
procedure Reset3DTransforms;
procedure Set3DAmbient;
procedure Get3DCount;
procedure Set3DItemColor;
procedure RGBToColor;
procedure Set3DLights;
procedure Set3DObjectColor;
procedure Set3DObjectAlpha;
procedure Set3DBackground;
procedure Load3DFile;
procedure Save3DFile;
procedure FitTo3DWindow;
procedure Copy3DObjects;
procedure Test3DHit;
procedure Mouse3DControl;
procedure Set3DText;
procedure Get3DObjectInfo;
procedure Scale3DObject;

procedure Set3DTexture;
procedure Set3DTextureParams;
procedure Set3DTextureFlags;
procedure Set3DViewerMode;
procedure Get3DObjPosRot;
procedure Set3DObjectData;
procedure Orient3DObject;
procedure Set3DMaterials;
procedure Show3DNormals;
procedure Get3DListHandle;
procedure Set3DStrokeText;
procedure Get3DObjectName;

implementation

uses GL3DPrimatives, I2LGlobal,XPLDataTypes, I2lIntrinsics;


procedure Intialize3DGraphics(Viewer: TGLViewer);
begin
GLIntializeGraphics(Viewer);
end;


procedure Enable3DViewer;
{150 Enable3DViewer}
{Prototype:  Enable3DViewer(Enable); }
begin
GLViewerEnable(PopStack<>0);
end;



procedure Set3DWindow;
{151 Set3DWindow}
{Prototype:  Set3DWindow(Left,Top,Width,Height); }
var Left,Top,Width,Height: TI2LWord;
begin
Height:=PopStack;
Width:=PopStack;
Top:=PopStack+GlobalConsole.VGABox.Top;
Left:=PopStack+GlobalConsole.VGABox.Left;

GLViewerWindow(Left,Top,Width,Height);
end;



procedure Set3DRenderMode;
{152 Set3DRenderMode}
{Prototype:  Set3DRenderMode(Handle,Item,Mode); }
var Handle,Item,Mode: TI2LWord;
begin
Mode:=PopStack;
Item:=PopStack;
Handle:=PopStack;
GLSetRenderMode(Handle,Item,Mode);
end;



procedure Add3DObject;
{153 Add3DObject}
{Prototype:  Add3DObject(Parent,ObjType,Name); }
var Parent,ObjType,Inx: TI2LWord;
var Name: string;
begin
Inx:=PopStack;
Name:=ProgramStore.GetDataString(Inx,UseMSBStrings);
ObjType:=PopStack;
Parent:=PopStack;
PushStack(GLAddObject(Parent, Name, T3DObjectType(ObjType)));
end;



procedure Delete3DObject;
{154 Delete3DObject}
{Prototype:  Delete3DObject(Handle); }
var Handle: TI2LWord;
begin
Handle:=PopStack;
GLDeleteObject(Handle);
end;


procedure Position3DObject;
{155 Position3DObject}
{Prototype:  Position3DObject(Handle,X,Y,Z); }
var Handle: TI2LWord;
var X,Y,Z: double;
begin
Z:=PopDouble;
Y:=PopDouble;
X:=PopDouble;
Handle:=PopStack;
GLPositionObject(Handle,X,Y,Z);
end;



procedure Rotate3DObject;
{156 Rotate3DObject}
{Prototype:  Rotate3DObject(Handle,Pitch,Yaw,Roll); }
var Handle: TI2LWord;
var Pitch,Yaw,Roll: double;
begin
Roll:=PopDouble;
Yaw:=PopDouble;
Pitch:=PopDouble;
Handle:=PopStack;
GLRotateObject(Handle,Pitch,Yaw,Roll);
end;



procedure Add3DTriangle;
{157 Add3DTriangle}
{Prototype:  Add3DTriangle(Handle,X1,Y1,Z1, X2,Y2,Z2, X3,Y3,Z3,Color); }
var Handle,Color: TI2LWord;
var X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3: double;
begin
Color:=PopStack;
Z3:=PopDouble; Y3:=PopDouble; X3:=PopDouble;
Z2:=PopDouble; Y2:=PopDouble; X2:=PopDouble;
Z1:=PopDouble; Y1:=PopDouble; X1:=PopDouble;
Handle:=PopStack;
GLAddTriangle(Handle,X1,Y1,Z1, X2,Y2,Z2, X3,Y3,Z3,Color);
end;



procedure Add3DRectangle;
{158 Add3DTriangle}
{Prototype:  Add3DRectangle(Handle,X1,Y1,Z1, X2,Y2,Z2, X3,Y3,Z3, X4,Y4,Z4, Color); }
var Handle,Color: TI2LWord;
var X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3,X4,Y4,Z4: double;
begin
Color:=PopStack;
Z4:=PopDouble; Y4:=PopDouble; X4:=PopDouble;
Z3:=PopDouble; Y3:=PopDouble; X3:=PopDouble;
Z2:=PopDouble; Y2:=PopDouble; X2:=PopDouble;
Z1:=PopDouble; Y1:=PopDouble; X1:=PopDouble;
Handle:=PopStack;
GLAddRectangle(Handle,X1,Y1,Z1, X2,Y2,Z2, X3,Y3,Z3, X4,Y4,Z4, Color);
end;


procedure Add3DLine;
{159 Add3DLine}
{Prototype:  Add3DLine(Handle,X1,Y1,Z1, X2,Y2,Z2, Width, Color); }
var Handle,Width,Color: TI2LWord;
var X1,Y1,Z1,X2,Y2,Z2: double;
begin
Color:=PopStack;
Width:=PopStack;
Z2:=PopDouble; Y2:=PopDouble; X2:=PopDouble;
Z1:=PopDouble; Y1:=PopDouble; X1:=PopDouble;
Handle:=PopStack;
GLAddLine(Handle,X1,Y1,Z1, X2,Y2,Z2,Width, Color);
end;


{Intrinsic #160 - Currently unused ------------------------------------------}


procedure Update3DViewer;
{161 Update3DViewer}
{Prototype:  Update3DViewer; }
begin
GLUpdateViewer;
end;



procedure Set3DNormals;
{162 Set3DNormals}
{Prototype:  Set3DNormals(Handle,CreaseAngle); }
var Handle: TI2LWord;
var CreaseAngle: double;
begin
CreaseAngle:=PopDouble;
Handle:=PopStack;
GLSetNormals(Handle,CreaseAngle);
end;



procedure Clear3DData;
{163 Clear3DObject}
{Prototype:  Clear3DData(Handle); }
var Handle: TI2LWord;
begin
Handle:=PopStack;
GLClearData(Handle);
end;





procedure Get3DViewerInfo;
{164 Get3DInfo}
{Prototype:  Get3DViewerInfo(InfoIndex); }
var InfoIndex: TI2LWord;
begin
InfoIndex:=PopStack;
PushStack(GLGetViewerInfo(InfoIndex));
end;



procedure Set3DBackColor;
{165 Set3DBackColor}
{Prototype:  Set3DBackColor(Color); }
var Color: TI2LWord;
begin
Color:=PopStack;
GLSetBackgroundColor(Color);
end;



procedure Reset3DTransforms;
{166 Reset3DTransforms}
{Prototype:  Reset3DTransforms(Handle); }
var Handle: TI2LWord;
begin
Handle:=PopStack;
GLResetTransforms(Handle);
end;



procedure Set3DAmbient;
{167 Set3DAmbient}
{Prototype:  Set3DAmbient(Color); }
var Color: TI2LWord;
begin
Color:=PopStack;
GLSetAmbient(Color);
end;



procedure Get3DCount;
{168 Add3DTexture}
{Prototype:  Get3DCount(Handle,Index); }
var Handle,Index: TI2LWord;
begin
Index:=PopStack;
Handle:=PopStack;
PushStack(GLGetCount(Handle,Index));
end;



procedure Set3DItemColor;
{169 Set3DItemColor}
{Prototype:  Set3DItemColor(Handle,Index,C1,C2,C3); }
var Handle,Index,C1,C2,C3: TI2LWord;
begin
C3:=PopStack;
C2:=PopStack;
C1:=PopStack;
Index:=PopStack;
Handle:=PopStack;
GLSetItemColor(Handle,Index,C1,C2,C3);
end;



procedure RGBToColor;
{170 RGBToColor}
{Prototype:  RGBToColor(R,G,B,A); }
var R,G,B,A: integer;
begin
A:=PopStack;
B:=PopStack;
G:=PopStack;
R:=PopStack;
PushStack(TranslateColor(R,G,B)+(A shl 24));
end;



procedure Set3DLights;
{171 Set3DLights}
{Prototype:  Set3DLights(Index,Enable,Mode,X,Y,Z,Color); }
var Index,Enable,Mode,Color: TI2LWord;
var X,Y,Z: double;
begin
Color:=PopStack;
Z:=PopDouble;
Y:=PopDouble;
X:=PopDouble;
Mode:=PopStack;
Enable:=PopStack;
Index:=PopStack;
GLSetLights(Index,Enable,Mode,X,Y,Z,Color);
end;




procedure Set3DObjectColor;
{172 Set3DObjectColor}
{Prototype:  Set3DObjectColor(Handle,Color); }
var Handle,Color: TI2LWord;
begin
Color:=PopStack;
Handle:=PopStack;
GLSetObjectColor(Handle,Color);
end;


procedure Set3DObjectAlpha;
{173 Set3DObjectAlpha}
{Prototype:  Set3DObjectAlpha(Handle,Enable,DepthCheck,BackBlend,Flags,Trans); }
var Handle,Enable,DepthCheck,BackBlend,Flags: TI2LWord;
var Trans: double;
begin
Trans:=PopDouble;
Flags:=PopStack;
BackBlend:=PopStack;
DepthCheck:=PopStack;
Enable:=PopStack;
Handle:=PopStack;
GLSetObjectAlpha(Handle,Enable,DepthCheck,BackBlend,Flags,Trans);
end;



procedure Set3DBackground;
{174 Set3DBackground}
{Prototype: Set3DBackground(BMHandle,Enable,PosX,PosY,PosZ,ScaleX,ScaleY); }
var Enable: TI2LWord;
var BMHandle: TI2LWord;
var BM: TBitmap;
var Pos: T3DVector;
var Scale: T2DVector;
begin
BM:=nil;
Scale.Y:=PopDouble;
Scale.X:=PopDouble;

Pos.Z:=PopDouble;
Pos.Y:=PopDouble;
Pos.X:=PopDouble;

Enable:=PopStack;
BMHandle:=PopStack;
GlobalConsole.VGABox.BitmapManager.GetBitmapByHandle(BMHandle,BM);
GLSetBackgroundBM(BM,Enable<>0,Pos,Scale);
end;



procedure Load3DFile;
{175 Load3DFile}
{Prototype: Load3DFile(Filename); }
var Filename: string;
var Inx: TI2LWord;
begin
Inx:=PopStack;
Filename:=ProgramStore.GetDataString(Inx,UseMSBStrings);
GLLoadFile(Filename);
end;



procedure Save3DFile;
{176 Save3DFile}
{Prototype: Save3DFile(Filename); }
var Filename: string;
var Inx: TI2LWord;
begin
Inx:=PopStack;
Filename:=ProgramStore.GetDataString(Inx,UseMSBStrings);
GLSaveFile(Filename);
end;


procedure FitTo3DWindow;
{177 FitTo3DWindow}
{Prototype: FitTo3DWindow(Handle,Index); }
var Handle,Index: TI2LWord;
begin
Index:=PopStack;
Handle:=PopStack;
GLFitToWindow(Handle,Index);
end;



procedure Copy3DObjects;
{178 Copy3DObjects}
{Prototype: Copy3DObjects(ToObj,FromObj); }
var ToObj,FromObj: TI2LWord;
begin
FromObj:=PopStack;
ToObj:=PopStack;
GLCopyObjects(ToObj,FromObj);
end;




procedure Test3DHit;
{179 Test3DHit}
{Prototype: boolean:=Test3DHit(X,Y, addr Handle, addr TriIndex); }
var X,Y,Handle,TriIndex,HitHandle, HitIndex: TI2LWord;
var Hit: boolean;
begin
TriIndex:=PopStack;
Handle:=PopStack;
Y:=PopStack; X:=PopStack;

Hit:=GLHitTest(X,Y,HitHandle, HitIndex);
ProgramStore.SetDataWord(Handle,HitHandle);
ProgramStore.SetDataWord(TriIndex,HitIndex);
PushXPLBoolean(Hit);
end;



procedure Mouse3DControl;
{180 Mouse3DControl}
{Prototype: Mouse3DControl(Enable,AutoUpdate,AutoAnimate); }
begin
GlobalConsole.GLAutoAnimate:=PopStack<>0;
GlobalConsole.GLAutoUpdate:=PopStack<>0;
GlobalConsole.Mouse3DCntrl:=PopStack<>0;
end;


procedure Set3DText;
{181 Set3DText}
{Prototype: Set3DText(Handle,String,Depth); }
var Handle,Inx: TI2LWord;
var Depth: double;
var Text: string;
begin
Depth:=PopDouble;
Inx:=PopStack;
Text:=ProgramStore.GetDataString(Inx,UseMSBStrings);
Handle:=PopStack;
GLSetText(Handle, Text, GlobalConsole.VGABox.BitmapManager.GetFont(-1),Depth);
end;


procedure Get3DObjectInfo;
{182 Get3DObjectInfo}
{Prototype: Get3DObjectInfo(Handle,addr Parent,addr ObjType); }
var Handle,ParentAddress,TypeAddress: TI2LWord;
var Parent: TI2LWord;
var ObjType: T3DObjectType;
begin
TypeAddress:=PopStack;
ParentAddress:=PopStack;
Handle:=PopStack;

GLGetObjectInfo(Handle,Parent,ObjType);
ProgramStore.SetDataWord(ParentAddress,Parent);
ProgramStore.SetDataWord(TypeAddress,integer(ObjType));
end;



procedure Scale3DObject;
{183 Scale3DObject}
{Prototype:  Scale3DObject(Handle,X,Y,Z); }
var Handle: TI2LWord;
var X,Y,Z: double;
begin
Z:=PopDouble;
Y:=PopDouble;
X:=PopDouble;
Handle:=PopStack;
GLSetObjectScale(Handle,MakeVector3d(X,Y,Z));
end;

{------------------------------------------------------------------------------}

procedure Set3DTexture;
{184 Set3DTexture}
{Prototype:  Set3DTexture(Handle, Mode, SubMode, addr BMHandles,BMPCount); }
var Handle,Mode,SubMode,BMHandles,Count: TI2LWord;
var BMArray: array of TBitmap;
var I,Inx: integer;
begin
Count:=PopStack;
BMHandles:=PopStack;
SubMode:=PopStack;
Mode:=PopStack;
Handle:=PopStack;
SetLength(BMArray,Count);
for I:=0 to High(BMArray) do
	begin
	Inx:=BMHandles+I*IntBytes;
	GlobalConsole.VGABox.BitmapManager.GetBitmapByHandle(I2LProgram.GetDataWord(Inx),BMArray[I]);
	end;
GLSetTexture(Handle,TTextureMode(Mode),SubMode,BMArray);
end;



procedure Set3DTextureParams;
{185 Set3DTextureParams}
{Prototype:  Set3DTextureParams(Handle, VarIndex, X,Y,Z,W); }
var Handle,VarIndex: TI2LWord;
var X,Y,Z,W: double;
begin
W:=PopDouble;  Z:=PopDouble; Y:=PopDouble; X:=PopDouble;
VarIndex:=PopStack;
Handle:=PopStack;
GLSetTextureParams(Handle, TTextureParams(VarIndex), X,Y,Z,W);
end;



procedure Set3DTextureFlags;
{186 Set3DTextureFlags}
{Prototype:  Set3DTextureFlags(Handle, VarIndex, Enable); }
var Handle,VarIndex,Enable: TI2LWord;
begin
Enable:=PopStack;
VarIndex:=PopStack;
Handle:=PopStack;
GLSetTextureFlags(Handle,TTextureFlags(VarIndex),Enable<>0);
end;



procedure Set3DViewerMode;
{187 Set3DViewerMode}
{Prototype:  Set3DViewerMode(Item,Mode); }
var Item,Mode: TI2LWord;
begin
Mode:=PopStack;
Item:=PopStack;
GLSetViewerMode(Item,Mode);
end;



procedure Get3DObjPosRot;
{188 Get3DObjPosRot}
{Prototype:  Get3DObjPosRot(Handle, addr X, addr Y, addr Z, addr Pitch, addr Yaw, addr Roll); }
var XAdd, YAdd, ZAdd, PitchAdd, YawAdd, RollAdd: TI2LWord;
var X, Y, Z, Pitch, Yaw, Roll: double;
var Handle: TI2LWord;
begin
RollAdd:=PopRealPointer;
YawAdd:=PopRealPointer;
PitchAdd:=PopRealPointer;
ZAdd:=PopRealPointer;
YAdd:=PopRealPointer;
XAdd:=PopRealPointer;
Handle:=PopStack;

GLGetObjectPos(Handle,X, Y, Z, Pitch, Yaw, Roll);
ProgramStore.SetDataDouble(XAdd,X);
ProgramStore.SetDataDouble(YAdd,Y);
ProgramStore.SetDataDouble(ZAdd,Z);
ProgramStore.SetDataDouble(PitchAdd,Pitch);
ProgramStore.SetDataDouble(YawAdd,Yaw);
ProgramStore.SetDataDouble(RollAdd,Roll);
end;




procedure Set3DObjectData;
{189 Set3DVObjectData}
{Prototype:  Set3DVObjectData(Handle,Array,Count,Color,Width); }
var Handle,Count,Color,Width: TI2LWord;
var RealInx: TI2LWord;
var DoubleArray: PDoubleArray;
begin
Width:=PopStack;
Color:=PopStack;
Count:=PopStack;
Dec(StackPtr,IntsPerReal-1);
RealInx:=PopRealPointer;
Handle:=PopStack;
DoubleArray:=I2LProgram.GetDataPDoubleArray(RealInx);
GLSetObjectData(Handle,DoubleArray,Count,Color,Width);
end;


procedure Orient3DObject;
{190 Orient3DObject}
{Prototype:  Orient3DObject(Handle,Mode,DirX,DirY,DirZ,UpX,UpY,UpZ); }
var Handle,Mode: TI2LWord;
var Dir,Up: T3DVector;
begin
Up.Z:=PopDouble;
Up.Y:=PopDouble;
Up.X:=PopDouble;
Dir.Z:=PopDouble;
Dir.Y:=PopDouble;
Dir.X:=PopDouble;
Mode:=PopStack;
Handle:=PopStack;
GLOrientObject(Handle,Mode,Dir,Up);
end;



procedure Set3DMaterials;
{191 Set3DMaterials}
{Prototype:  Set3DMaterials(Handle,Mode,Color); }
var Handle,Mode,Color: TI2LWord;
begin
Color:=PopStack;
Mode:=PopStack;
Handle:=PopStack;
GLSetMaterials(Handle,Mode,Color);
end;



procedure Show3DNormals;
{192 Show3DNormals}
{Prototype:  Show3DNormals(Handle,Enable); }
var Handle,Enable: TI2LWord;
begin
Enable:=PopStack;
Handle:=PopStack;
GLShowNormals(Handle,Enable<>0);
end;



procedure Get3DListHandle;
{193 Get3DListHandle}
{Prototype: Get3DListHandle(ParentFrame,ListType,Index); }
var ParentFrame,ListType,Index: TI2LWord;
begin
Index:=PopStack;
ListType:=PopStack;
ParentFrame:=PopStack;
PushStack(GLGetListHandle(ParentFrame,ListType,Index));
end;

procedure Set3DStrokeText;
{194 Set3DStrokeText}
{Prototype: Set3DStrokeText(Handle, UsePos, Text, PosX, PosY, PosZ, Scale, Color); }
var Handle,UsePos,Color,Inx: TI2LWord;
var Pos: T3DVector;
var Scale: double;
var Text: string;
begin
Color:=PopStack;
Scale:=PopDouble;
Pos.Z:=PopDouble;
Pos.Y:=PopDouble;
Pos.X:=PopDouble;
Inx:=PopStack;
Text:=ProgramStore.GetDataString(Inx,UseMSBStrings);
UsePos:=PopStack;
Handle:=PopStack;
GLSetStrokeText(Handle, UsePos<>0, Text, Pos, Scale, Color);
end;


procedure Get3DObjectName;
{195 Get3DObjectName}
{Prototype: Get3DObjectName(Handle, Name, MaxLength); }
var Handle,StrInx,MaxLen: integer;
var Name: string;
begin
MaxLen:=PopStack;
StrInx:=PopStack;
Handle:=PopStack;
Name:=GLGetObjectName(Handle);
if Length(Name)>MaxLen then SetLength(Name,MaxLen);
ProgramStore.SetDataString(Name,StrInx);
end;

end.
