unit I3DMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,GL3DFigures,
  Dialogs, ExtCtrls, paintpan, GLViewer, GLRenderer,GLFrame,GLMesh,GLLines,StdCtrls, SpinButtons,
  intspin,Contnrs,Vector, ConsoleWindow, Buttons, subtimer, Onoffbox,
  CodeEditor, ComCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    EnableChk: TCheckBox;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    LeftSpin: TIntegerSpin;
    Label2: TLabel;
    TopSpin: TIntegerSpin;
    Label3: TLabel;
    WidthSpin: TIntegerSpin;
    Label4: TLabel;
    HeightSpin: TIntegerSpin;
    SetPosBtn: TButton;
    Button1: TButton;
    RadioGroup1: TRadioGroup;
    PresetBtn: TButton;
    Button2: TButton;
    ConsoleWnd: TConsoleWindow;
    Memo1: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure EnableChkClick(Sender: TObject);
    procedure SetPosBtnClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure ConsoleWndMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ConsoleWndMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ConsoleWndMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PresetBtnClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses GL3DPrimatives;

{$R *.dfm}



{------------------------------------------------------------------------------}



procedure TForm1.FormCreate(Sender: TObject);
begin
GLIntializeGraphics(Form1.ConsoleWnd.GLViewer);
Form1.LeftSpin.Value:=ConsoleWnd.GLViewer.Left;
Form1.TopSpin.Value:=ConsoleWnd.GLViewer.Top;
Form1.WidthSpin.Value:=ConsoleWnd.GLViewer.Width;
Form1.HeightSpin.Value:=ConsoleWnd.GLViewer.Height;
end;

procedure TForm1.EnableChkClick(Sender: TObject);
begin
GLViewerEnable(EnableChk.Checked);
end;

procedure TForm1.SetPosBtnClick(Sender: TObject);
begin
GLViewerWindow(LeftSpin.Value,TopSpin.Value,WidthSpin.Value,HeightSpin.Value);
end;

var Cube: T3DObjHandle;

const CubePoints: array [0..11] of TTriangle = (
 {Front}
 (P1:(X:-1; Y: -1; Z: 1); P2:(X:1; Y: -1; Z: 1);  P3:(X:1; Y: 1; Z: 1)),
 (P1:(X:-1; Y: -1; Z: 1); P2:(X:1; Y: 1; Z: 1);  P3:(X:-1; Y: 1; Z: 1)),
 {Right Side}
 (P1:(X:1; Y: -1; Z: 1); P2:(X:1; Y: -1; Z: -1);  P3:(X:1; Y: 1; Z: -1)),
 (P1:(X:1; Y: -1; Z: 1); P2:(X:1; Y: 1; Z: -1);  P3:(X:1; Y: 1; Z: 1)),
 {Back}
 (P1:(X:1; Y: -1; Z: -1); P2:(X:-1; Y: -1; Z: -1);  P3:(X:-1; Y: 1; Z: -1)),
 (P1:(X:1; Y: -1; Z: -1); P2:(X:-1; Y: 1; Z: -1);  P3:(X:1; Y: 1; Z: -1)),
 {Left Side}
 (P1:(X:-1; Y: -1; Z: -1); P2:(X:-1; Y: -1; Z: 1);  P3:(X:-1; Y: 1; Z: 1)),
 (P1:(X:-1; Y: -1; Z: -1); P2:(X:-1; Y: 1; Z: 1);  P3:(X:-1; Y: 1; Z: -1)),
 {Top}
 (P1:(X:-1; Y: 1; Z: 1); P2:(X:1; Y: 1; Z: 1);  P3:(X:1; Y: 1; Z: -1)),
 (P1:(X:-1; Y: 1; Z: 1); P2:(X:1; Y: 1; Z: -1);  P3:(X:-1; Y: 1; Z: -1)),
 {Bottom}
 (P1:(X:1; Y: -1; Z: 1); P2:(X:-1; Y: -1; Z: 1);  P3:(X:-1; Y: -1; Z: -1)),
 (P1:(X:1; Y: -1; Z: 1); P2:(X:-1; Y: -1; Z: -1);  P3:(X:1; Y: -1; Z: -1))
 );


procedure TForm1.Button1Click(Sender: TObject);
var I: integer;
begin
Cube:=GLAddObject(-1,t3dMesh);
for I:=0 to High(CubePoints) do
 GLAddTriangle(Cube,CubePoints[I],clRed);
GLSetNormals(Cube);
GLUpdateViewer;
end;



procedure TForm1.RadioGroup1Click(Sender: TObject);
var Mode: TRenderMode;
begin
case RadioGroup1.ItemIndex of
 0: Mode:=rmWireFrame;
 1: Mode:=rmFlatFace;
 2: Mode:=rmSmoothFace;
 end;
GLSetRenderMode(Cube, Mode);
GLUpdateViewer;
end;


procedure TForm1.ConsoleWndMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
ConsoleWnd.GLViewer.BaseFrame.HandleMouseDown(X,Y);
end;


procedure TForm1.ConsoleWndMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
ConsoleWnd.GLViewer.BaseFrame.HandleMouseMove(Shift,X,Y);
ConsoleWnd.GLViewer.Invalidate;
end;


procedure TForm1.ConsoleWndMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
ConsoleWnd.GLViewer.BaseFrame.HandleMouseUp;
end;

procedure TForm1.PresetBtnClick(Sender: TObject);
begin
LeftSpin.Value:=50;
TopSpin.Value:=50;
WidthSpin.Value:=500;
HeightSpin.Value:=500;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
ConsoleWnd.Repaint;
ConsoleWnd.GLViewer.Enabled:=False;
ConsoleWnd.GLViewer.Visible:=False;
ConsoleWnd.GLViewer.ScreenColor:=clBlue;
GLViewerWindow(0,0,1,1);
GLViewerWindow(50,50,400,400);
ConsoleWnd.GLViewer.Enabled:=True;
ConsoleWnd.GLViewer.Visible:=True;
ConsoleWnd.GLViewer.Repaint;
end;

end.
