unit ES32Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ConsoleWindow,DSupport,IntVector, Menus,
  Scrllwnd, Onoffbox, Buttons, Autobttn;

type
  TForm1 = class(TForm)
    ConsoleWnd: TConsoleWindow;
    Panel10: TPanel;
    Panel11: TPanel;
    CharPosDis: TLabel;
    RefreshTimer: TTimer;
    PopupMenu1: TPopupMenu;
    Device10Output1: TMenuItem;
    RerunProgram1: TMenuItem;
    RunOnOff: TOnOffBox;
    ZoomPanel: TPanel;
    ZoomOutBtn: TAutoButton;
    ZoomInBtn: TAutoButton;
    ResetZoomBtn: TAutoButton;
    Panel13: TPanel;
    MouseDis: TLabel;
    VirtualMouseDis: TLabel;
    Panel5: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure ConsoleWndMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure RefreshTimerTimer(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Device10Output1Click(Sender: TObject);
    procedure RerunProgram1Click(Sender: TObject);
    procedure ResetZoomBtnClick(Sender: TObject);
    procedure ZoomOutBtnClick(Sender: TObject);
    procedure ZoomInBtnClick(Sender: TObject);
    procedure ConsoleWndScaleChange(Sender: TObject);
    procedure ConsoleWndControlC(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses I2LInterp, I2LGlobal, XPLDataTypes, XPLCompiler, IDEDebugInfo,
  XRTGlobal;

{$R *.dfm}
{$R DummyProg.res}



const TestCode16 = ';000007*0000;0000090800240007*0000;000848656C6C6F20576F726C64;0012E4;0013^00060B*00080C0C06$';



var CodeStr: string;

var FirstActivate: boolean;



procedure HandleRuntimeError(E: TObject; Offset: integer);
var EMsg,S: string;
var B: boolean;
var PC: integer;
begin
if E is Exception then EMsg:=Exception(E).Message else EMsg:='';
PC:=LastPC+Offset;
S:='Runtime Error: '+EMsg+CRLF_Char;
S:=S+' PC = '+IntToStr(PC)+' - $'+IntToHex(PC,Intbytes);
//MessageDlg(S,mtWarning, [mbOK], 0);
Form1.ConsoleWnd.VGABox.StringOut(S);
end;




procedure ExecuteProgram;
var Code: string;
var MR: integer;
begin
RunFromDos:=True;
try
Form1.RefreshTimer.Enabled:=True;
Form1.RunOnOff.BoxOn:=True;
Form1.ConsoleWnd.SetFocus;
try
RunProgram(CodeStr,Form1.ConsoleWnd);
except
 HandleRuntimeError(ExceptObject,ProgramStore.ProgData.BaseAddress);
 end;
Form1.ConsoleWnd.VGABox.Repaint;
finally
 Form1.RunOnOff.BoxOn:=False;
 Form1.RefreshTimer.Enabled:=False;
 if CloseOnTerminate then Form1.Close;
 end;
end;


procedure LoadCodeFromResource;
var RS: TResourceStream;
begin
if IntBytes = 2 then RS:=TResourceStream.Create(HInstance,'I2LCODE16',RT_RCDATA)
else RS:=TResourceStream.Create(HInstance,'I2LCODE32',RT_RCDATA);
try
SetLength(CodeStr, RS.Size);
if RS.Size > 0 then RS.Read(CodeStr[1], RS.Size);
finally RS.Free; end;
end;



procedure TForm1.FormCreate(Sender: TObject);
begin
FirstActivate:=True;
ConsoleWnd.Color:=clBlack;
ConsoleWnd.VGABox.ShowCursor:=False;
Form1.Caption:=ExtractNamePart(Application.ExeName);
LoadCodeFromResource;
end;



procedure TForm1.ConsoleWndMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
var P,PV: TPoint;
begin
P:=Point(X,Y);
PV:=ConsoleWnd.MouseState.Pos;
MouseDis.Caption:=PointToString(P);
VirtualMouseDis.Caption:=PointToString(PV);
P:=IntVector.IntVectorDivide(PV,ConsoleWnd.VGABox.CellSize);
CharPosDis.Caption:=PointToString(P);
end;


procedure TForm1.RefreshTimerTimer(Sender: TObject);
begin
Form1.ConsoleWnd.VGABox.Repaint;
end;



procedure TForm1.FormActivate(Sender: TObject);
begin
if FirstActivate then ExecuteProgram;
FirstActivate:=False;
end;


procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
KillProgram;
end;



procedure TForm1.Device10Output1Click(Sender: TObject);
begin
DoDebugInfo(False);
end;

procedure TForm1.RerunProgram1Click(Sender: TObject);
begin
ExecuteProgram;
end;





procedure TForm1.ZoomInBtnClick(Sender: TObject);
begin
ConsoleWnd.ScaleFactor:=GetNextValue(ConsoleWnd.ScaleFactor );
Form1.ZoomPanel.Caption:=FloatToStr(ConsoleWnd.ScaleFactor);
end;



procedure TForm1.ResetZoomBtnClick(Sender: TObject);
begin
ConsoleWnd.ScaleFactor:=1;
Form1.ZoomPanel.Caption:=FloatToStr(ConsoleWnd.ScaleFactor);
end;



procedure TForm1.ZoomOutBtnClick(Sender: TObject);
begin
ConsoleWnd.ScaleFactor:=GetPreviousValue(ConsoleWnd.ScaleFactor );
Form1.ZoomPanel.Caption:=FloatToStr(ConsoleWnd.ScaleFactor);
end;

procedure TForm1.ConsoleWndScaleChange(Sender: TObject);
begin
Form1.ZoomPanel.Caption:=FloatToStr(ConsoleWnd.ScaleFactor);
end;

procedure TForm1.ConsoleWndControlC(Sender: TObject);
begin
if not TrapControlC then KillProgram;
end;

end.
