unit I2LRawPrint;

interface

uses Windows,Printers,WinSpool;

procedure RawPrintText(S: string);


implementation


{ RawDataToPrinter - sends binary data directly to a printer}
{ }
{ Params:}
{   szPrinterName - NULL terminated string specifying printer name}
{   lpData        - Pointer to raw data bytes}
{   dwCount       - Length of lpData in bytes}
{ }
{ Returns: TRUE for success, FALSE for failure.}
{ }

function RawDataToPrinter(szPrinterName: LPSTR; lpData: pointer; dwCount: DWORD): boolean;
var hPrinter: cardinal     ;
var DocInfo: DOC_INFO_1 ;
var dwJob: DWORD      ;
var dwBytesWritten: DWORD      ;
begin
Result:=False;
{ Need a handle to the printer.}
if not OpenPrinter(szPrinterName, hPrinter, nil) then exit;

{ Fill in the structure with info about this 'document.'}
DocInfo.pDocName := 'My Document';
DocInfo.pOutputFile := nil;
DocInfo.pDatatype := 'RAW';

{ Inform the spooler the document is beginning.}
dwJob:=StartDocPrinter(hPrinter, 1, @DocInfo);
if dwJob = 0 then
	begin
	ClosePrinter(hPrinter);
	exit;
	end;
{ Start a page.}
if not StartPagePrinter(hPrinter) then
	begin
	EndDocPrinter(hPrinter);
	ClosePrinter(hPrinter);
	exit;
	end;

{ Send the data to the printer.}
if not WritePrinter(hPrinter, lpData, dwCount, dwBytesWritten) then
	begin
	EndPagePrinter(hPrinter);
	EndDocPrinter(hPrinter);
	ClosePrinter(hPrinter);
	exit;
	end;
{ End the page.}
if not EndPagePrinter(hPrinter) then
	begin
	EndDocPrinter(hPrinter);
	ClosePrinter(hPrinter);
	exit;
	end;
{ Inform the spooler that the document is ending.}
if not EndDocPrinter(hPrinter) then
	begin
	ClosePrinter(hPrinter);
	exit;
	end;
{ Tidy up the printer handle.}
ClosePrinter(hPrinter);
{ Check to see if correct number of bytes were written.}
if dwBytesWritten <> dwCount then exit;
Result:=True;
end;



procedure RawPrintText(S: string);
var Name: string;
begin
Name:=Printer.Printers[Printer.PrinterIndex];
RawDataToPrinter(PChar(Name),PChar(S),Length(S));
end;




end.
 