unit IDECanvasAttribs;

interface

uses 
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, SpinButtons, DSupport, IntVector, BitmapLib;

type
  TCanvasAttribFrm = class(TFrame)
    GroupBox3: TGroupBox;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label20: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    PenPosDis: TEditEx;
    PenWidthDis: TEditEx;
    FillColorDis: TEditEx;
    LineColorDis: TEditEx;
    PenModeDis: TEditEx;
    FillModeDis: TEditEx;
    FontSizeDis: TEditEx;
    FontStyleDis: TEditEx;
    FontNameDis: TEditEx;
    FontColorDis: TEditEx;
  private
    { Private declarations }
  public
    { Public declarations }
    procedure DisplayCanvasInfo(Canvas: TCanvas);
  end;

implementation

{$R *.dfm}

function GetPenModeStr(PM: TPenMode): string;
begin
case PM of
 pmCopy: Result:='Copy';
 pmXor: Result:='XOR';
 pmNot: Result:='Not';
 pmNotCopy: Result:='NotCopy';
 pmNotXor: Result:='NotXOR';
 pmMerge: Result:='Merge';
 pmNotMerge: Result:='NotMerge';
 pmMergePenNot: Result:='MergePenNot';
 pmMergeNotPen: Result:='MergeNotPen';
 pmMask: Result:='Mask';
 pmNotMask: Result:='NotMask';
 pmMaskPenNot: Result:='MaskPenNot';
 pmMaskNotPen: Result:='MaskNotPen';
 else Result:='Unknown';
 end;
end;



function GetFontStylesStr(FS: TFontStyles): string;
begin
Result:='';
if fsBold in FS then Result:=Result+'Bold,';
if fsItalic in FS then Result:=Result+'Italic,';
if fsUnderline in FS then Result:=Result+'Underline,';
if fsStrikeout in FS then Result:=Result+'StrikeOut';
end;



procedure DisplayColor(ED: TEditEx; Color: TColor);
var R,G,B: byte;
begin
ED.Color:=Color;
ED.Font.Color:=ContrastColor(Color);
ColorToRGBBytes(Color,R,G,B);
ED.Text:=IntToHex(R,2)+'-'+IntToHex(G,2)+'-'+IntToHex(B,2);
end;

procedure TCanvasAttribFrm.DisplayCanvasInfo(Canvas: TCanvas);
begin
PenPosDis.Text:=PointToString(Canvas.PenPos);
PenWidthDis.Text:=IntToStr(Canvas.Pen.Width);
PenModeDis.Text:=GetPenModeStr(Canvas.Pen.Mode);
DisplayColor(FillColorDis,Canvas.Brush.Color);
DisplayColor(LineColorDis,Canvas.Pen.Color);
FillModeDis.Text:=PickString(Canvas.Brush.Style=bsSolid,'Filled','Cleared');
FontSizeDis.Text:=IntToStr(Canvas.Font.Size);
FontStyleDis.Text:=GetFontStylesStr(Canvas.Font.Style);
FontNameDis.Text:=Canvas.Font.Name;
DisplayColor(FontColorDis,Canvas.Font.Color);
end;



end.
