unit IDEDebugInfo;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls,DSupport;

type
  TDebugInfoDlg = class(TForm)
    Panel1: TPanel;
    CancelBtn: TButton;
    Panel2: TPanel;
    DebugMemo: TMemo;
    Button1: TButton;
    HelpBtn: TBitBtn;
    procedure Button1Click(Sender: TObject);
    procedure DebugMemoKeyPress(Sender: TObject; var Key: Char);
    procedure CancelBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DebugInfoDlg: TDebugInfoDlg;

function OpenDebugOut(var C: char): boolean;
function OpenDebugIn(var C: char): boolean;
function CloseDebugOut(var C: char): boolean;
function CloseDebugIn(var C: char): boolean;
function DebugOut(var C: char): boolean;
function DebugIn(var C: char): boolean;

procedure DebugStringOut(S: string);


procedure DoDebugInfo(ShowHelpBtn: boolean);


implementation

{$R *.dfm}

var KeyBuffer: string;


function OpenDebugIn(var C: char): boolean;
begin
KeyBuffer:='';
Result:=True;
end;


function OpenDebugOut(var C: char): boolean;
begin
C:=#0;
DebugInfoDlg.DebugMemo.Clear;
Result:=True;
end;


Function DebugIn(var C: char): boolean;
begin
Result:=False;
Application.ProcessMessages;
Sleep(1);
if Length(KeyBuffer)>0 then
	begin
	C:=KeyBuffer[1];
	Delete(KeyBuffer,1,1);
	end
else C:=EOF_Char;
Result:=True;
end;



function DebugOut(var C: char): boolean;
begin
DebugInfoDlg.DebugMemo.SelText:=C;
Result:=True;
end;


procedure DebugStringOut(S: string);
begin
DebugInfoDlg.DebugMemo.SelText:=S;
end;



function CloseDebugIn(var C: char): boolean;
begin
C:=#0;
Result:=True;
end;


function CloseDebugOut(var C: char): boolean;
begin
C:=#0;
Result:=True;
end;


procedure TDebugInfoDlg.Button1Click(Sender: TObject);
begin
DebugMemo.Clear;
end;


procedure TDebugInfoDlg.DebugMemoKeyPress(Sender: TObject; var Key: Char);
begin
KeyBuffer:=KeyBuffer+Key;
end;


procedure DoDebugInfo(ShowHelpBtn: boolean);
begin
DebugInfoDlg.HelpBtn.Visible:=ShowHelpBtn;
DebugInfoDlg.Show;
end;

procedure TDebugInfoDlg.CancelBtnClick(Sender: TObject);
begin
Close;
end;

end.
