unit IDEDebugger;

interface

uses Windows, Types, Dialogs, Menus, Grids, StdCtrls, ScrollBarWindow,
  ScrollEditor, Buttons, ComCtrls, Controls, ExtCtrls, Classes,
  SysUtils, Graphics, Forms, Clipbrd, Math,
   DSupport, Autobttn,  ImgList, TreeViewEx,VCLLibrary,
  ImageList, Sockets, Onoffbox, StdActns, ActnList, ToolWin, ActnMan,
  ActnCtrls,IDEVariableLib, FancyButton, subtimer, SpinButtons, intspin,
  CheckBoxExt;

type
  TDebugDlg = class(TForm)
    SourcePopup: TPopupMenu;
    SetWatchAtCurosr1: TMenuItem;
    SetBreakAtCursor1: TMenuItem;
    FindDialog1: TFindDialog;
    SourcePanel: TPanel;
    WatchPanel: TPanel;
    PageControl1: TPageControl;
    TabSheet2: TTabSheet;
    WatchGrid: TDrawGrid;
    Panel2: TPanel;
    VariableBtn: TSpeedButton;
    WatchPropBtn: TSpeedButton;
    WatchBtn: TSpeedButton;
    ModifyBtn: TSpeedButton;
    BitmapBtn: TSpeedButton;
    TabSheet1: TTabSheet;
    Panel7: TPanel;
    DeleteBreakBtn: TSpeedButton;
    SetBreakBtn: TSpeedButton;
    ClearBreaksBtn: TBitBtn;
    BreakGrid: TDrawGrid;
    WatchSplit: TSplitter;
    Panel3: TPanel;
    Panel10: TPanel;
    Panel13: TPanel;
    PCDis: TLabel;
    Panel11: TPanel;
    OpcodeDis: TLabel;
    Panel5: TPanel;
    LineDis: TLabel;
    TopSplit: TSplitter;
    I2LPanel: TPanel;
    MemPopup: TPopupMenu;
    Base1: TMenuItem;
    LocalMemory1: TMenuItem;
    HeapStart1: TMenuItem;
    MemoryPanel: TPanel;
    BottomSplit: TSplitter;
    Panel9: TPanel;
    Label1: TLabel;
    StackGrid: TDrawGrid;
    Splitter1: TSplitter;
    Panel12: TPanel;
    Panel4: TPanel;
    I2LStepIntoBtn: TFancySpeedBtn;
    I2LStepOverBtn: TFancySpeedBtn;
    I2LExePointBtn: TSpeedButton;
    Label2: TLabel;
    I2LEditor: TScrollEditor;
    Panel8: TPanel;
    Panel14: TPanel;
    I2LLineDis: TLabel;
    Panel6: TPanel;
    StepIntoBtn: TFancySpeedBtn;
    StepOverBtn: TFancySpeedBtn;
    RunBtn: TSpeedButton;
    ResetBtn: TSpeedButton;
    StopBtn: TSpeedButton;
    SearchBtn: TSpeedButton;
    ExePointBtn: TSpeedButton;
    I2LCheck: TCheckBox;
    EditPageControl: TPageControl;
    TabSheet3: TTabSheet;
    DebugEditor: TScrollEditor;
    Panel1: TPanel;
    RunStateDis: TPanel;
    WatchPopup: TPopupMenu;
    Properties1: TMenuItem;
    Modify1: TMenuItem;
    ShowasBitmap1: TMenuItem;
    Delete1: TMenuItem;
    Add1: TMenuItem;
    AllVariables1: TMenuItem;
    ClearWatches1: TMenuItem;
    N1: TMenuItem;
    Run1: TMenuItem;
    StepInto1: TMenuItem;
    StepOver1: TMenuItem;
    Restart1: TMenuItem;
    ShowExecutionPoint1: TMenuItem;
    BreakPopup: TPopupMenu;
    AddBreakAtCursor1: TMenuItem;
    DeleteBreak1: TMenuItem;
    ClearAllBreakPoints1: TMenuItem;
    OpenFileatCursor1: TMenuItem;
    OpenBtn: TSpeedButton;
    OpenDialog1: TOpenDialog;
    RefreshBtn: TSpeedButton;
    FPUPanel: TPanel;
    Label5: TLabel;
    FPUGrid: TStringGrid;
    Splitter3: TSplitter;
    SystemBtn: TSpeedButton;
    NewWatchBtn: TSpeedButton;
    I2LHelpBtn: TBitBtn;
    SaveDialog1: TSaveDialog;
    OpenDialog2: TOpenDialog;
    OpenFileBtn: TSpeedButton;
    SaveFileBtn: TSpeedButton;
    CopyBtn: TSpeedButton;
    Panel15: TPanel;
    HeapDis: TLabel;
    Panel17: TPanel;
    StackDepthDis: TLabel;
    Help1Btn: TSpeedButton;
    ConfigBtn: TSpeedButton;
    ExpandedDisplayBtn: TSpeedButton;
    Panel18: TPanel;
    SubTimer: TSubTimer;
    MemPageControl: TPageControl;
    TabSheet4: TTabSheet;
    Panel19: TPanel;
    MemGrid: TDrawGrid;
    StatusBar: TPanel;
    Panel20: TPanel;
    CursorAddHexDis: TLabel;
    CursorDecDis: TPanel;
    Panel21: TPanel;
    CursorHexDis: TLabel;
    CursorAddDecDis: TPanel;
    WordHexDis: TLabel;
    WordDecDis: TPanel;
    SignedDecDis: TPanel;
    Panel24: TPanel;
    Label7: TLabel;
    VectorGrid: TDrawGrid;
    Splitter2: TSplitter;
    Panel16: TPanel;
    MoveUpBtn: TSpeedButton;
    MoveDnBtn: TSpeedButton;
    DeleteWatchBtn: TSpeedButton;
    ClearWatchBtn: TBitBtn;
    TabSheet6: TTabSheet;
    Panel28: TPanel;
    GroupBox2: TGroupBox;
    Label8: TLabel;
    Label9: TLabel;
    DecAddSpin: TIntegerSpin;
    HexAddSpin: TIntegerSpin;
    TypeRadio: TRadioGroupExt;
    Panel26: TPanel;
    HeapGrid: TDrawGrid;
    Panel27: TPanel;
    DeleteHeapBtn: TSpeedButton;
    InsertHeapBtn: TSpeedButton;
    ClearHeapBtn: TBitBtn;
    IndirectChk: TCheckBoxExt;
    HeapDownBtn: TSpeedButton;
    HeapUpBtn: TSpeedButton;
    TabSheet5: TTabSheet;
    SymbolGrid: TStringGrid;
    VarPopup: TPopupMenu;
    Copy1: TMenuItem;
    procedure StepIntoBtnClick(Sender: TObject);
    procedure RunBtnClick(Sender: TObject);
    procedure StepOverBtnClick(Sender: TObject);
    procedure ResetBtnClick(Sender: TObject);
    procedure DebugEditorChange(Sender: TObject);
    procedure BreakGridDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure DeleteBreakBtnClick(Sender: TObject);
    procedure ClearBreaksBtnClick(Sender: TObject);
    procedure WatchGridDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure VariableBtnClick(Sender: TObject);
    procedure DeleteWatchBtnClick(Sender: TObject);
    procedure ClearWatchBtnClick(Sender: TObject);
    procedure SetWatchAtCurosr1Click(Sender: TObject);
    procedure SetBreakAtCursor1Click(Sender: TObject);
    procedure WatchPropBtnClick(Sender: TObject);
    procedure ModifyBtnClick(Sender: TObject);
    procedure SearchBtnClick(Sender: TObject);
    procedure FindDialog1Find(Sender: TObject);
    procedure ExePointBtnClick(Sender: TObject);
    procedure DebugEditorMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure DebugEditorMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure StopBtnClick(Sender: TObject);
    procedure BitmapBtnClick(Sender: TObject);
    procedure WatchGridDblClick(Sender: TObject);
    procedure BreakGridDblClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure I2LEditorChange(Sender: TObject);
    procedure I2LExePointBtnClick(Sender: TObject);
    procedure I2LStepIntoBtnClick(Sender: TObject);
    procedure I2LStepOverBtnClick(Sender: TObject);
    procedure I2LCheckClick(Sender: TObject);
    procedure MemGridDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure Base1Click(Sender: TObject);
    procedure LocalMemory1Click(Sender: TObject);
    procedure HeapStart1Click(Sender: TObject);
    procedure MemGridMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure MemGridSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure MemGridSetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
    procedure MemGridKeyPress(Sender: TObject; var Key: Char);
    procedure OpenFileatCursor1Click(Sender: TObject);
    procedure OpenBtnClick(Sender: TObject);
    procedure MoveUpBtnClick(Sender: TObject);
    procedure MoveDnBtnClick(Sender: TObject);
    procedure RefreshBtnClick(Sender: TObject);
    procedure SystemBtnClick(Sender: TObject);
    procedure NewWatchBtnClick(Sender: TObject);
    procedure OpenFileBtnClick(Sender: TObject);
    procedure SaveFileBtnClick(Sender: TObject);
    procedure CopyBtnClick(Sender: TObject);
    procedure Help1BtnClick(Sender: TObject);
    procedure ConfigBtnClick(Sender: TObject);
    procedure ExpandedDisplayBtnClick(Sender: TObject);
    procedure WatchGridClick(Sender: TObject);
    procedure VectorGridDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure HeapGridDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure InsertHeapBtnClick(Sender: TObject);
    procedure DeleteHeapBtnClick(Sender: TObject);
    procedure ClearHeapBtnClick(Sender: TObject);
    procedure DecAddSpinChange(Sender: TObject);
    procedure HexAddSpinChange(Sender: TObject);
    procedure HeapGridSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure TypeRadioClick(Sender: TObject);
    procedure IndirectChkClick(Sender: TObject);
    procedure HeapGridGetEditText(Sender: TObject; ACol, ARow: Integer;
      var Value: String);
    procedure HeapGridSetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
    procedure HeapDownBtnClick(Sender: TObject);
    procedure HeapUpBtnClick(Sender: TObject);
    procedure StackGridDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure VectorGridDblClick(Sender: TObject);
    procedure DebugEditorMouseLeave(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var DebugDlg: TDebugDlg;

var HighLightEditor: TScrollEditor;	{Editor where the highlight point is}

var MouseDigits: integer;
var MouseRealFormat: TRealFormat;


procedure DoDebugConsole;
procedure ShowCodeState;
procedure UpdateWatchGrid;
procedure GotoMemAddress(Add: integer);

function InDebugMode: boolean;


function SetDebugEditor(Filename: string): TScrollEditor;
function GetDebugEditor(Filename: string): TScrollEditor;
function CompileAndLoadProgram: boolean;


implementation

uses XPLCompiler, I2LInterp, I2LGlobal, EBXMain, IDECompileMessages,
  I2LLoader, IDEVariables, I2LDataTypes, XPLDataTypes, IDEWatchFormat,
  IDEModifyVariable, IDEBitmapDlg, IDEStackDump, IDEGlobal, I2LDisasm,
  IDEProgressDlg, IDESystemDlg, IDEVGAPalette,
  IDEExpression, IDEDebugFile, IDEDebugConfig, IDEVariableDis,
  IDEHeapAnalyzer,IDEStructDebug,IDEStruncts;

{$R *.dfm}


var EndOfProgram: boolean;	{Flags that we hit the end of the program}
var OldLine: integer;		{Last line debugged - for single step routines}

var SourceInfo: TSourceInfo;	{Defines current position in source file}
var I2LCode: string;		{Raw I2L code}

var DebugAbort: boolean;	{Abort full speed execution in the step-over and run commands }

{----------------- Tools to Add and handle extra Editors ----------------------}




function AddEditor(Filename: string): TScrollEditor;
{Add one tab sheet with an editor embedded in it}
var TS: TTabSheet;
var ED: TScrollEditor;
var P: integer;
var N: string;
begin
N:=ExtractFilename(Filename);
P:=DebugDlg.EditPageControl.PageCount+1;
TS:=TTabSheet.Create(DebugDlg);
TS.Name:='EditTab'+IntToStr(P);
TS.BorderWidth:=2;
TS.Caption:=N;
TS.PageControl:=DebugDlg.EditPageControl;

ED:=TScrollEditor.Create(DebugDlg);
ED.Parent:=TS;
ED.Name:='DebugEdit'+IntToStr(P);
ED.Align:=alClient;
ED.BevelInner:=bvRaised;
ED.BevelOuter:=bvLowered;
ED.BevelKind:=bkSoft;
ED.GutterSize:=10;
ED.KeyMapping:=kmXED;
ED.ReadOnly:=True;
ED.StandAlone:=True;

ED.PopupMenu:=DebugDlg.SourcePopup;
ED.OnMouseDown:=DebugDlg.DebugEditorMouseDown;
ED.OnMouseMove:=DebugDlg.DebugEditorMouseMove;
ED.OnChange:=DebugDlg.DebugEditorChange;
ED.LoadFromFile(Filename);
Result:=ED;
end;



procedure ClearEditors;
{Clear all editors and pages except the first, base editor}
var I: integer;
begin
for I:=DebugDlg.EditPageControl.PageCount-1 downto 1 do
	DebugDlg.EditPageControl.Pages[I].Free;
DebugDlg.EditPageControl.ActivePageIndex:=0;
end;



function GetVisibleEditor: TScrollEditor;
{Get editor on currently selected page}
begin
Result:=TScrollEditor(DebugDlg.EditPageControl.ActivePage.Controls[0]);
end;



function FindEditor(Filename: string): TScrollEditor;
{Check exising editors and return the one corresponding to Filename}
{Returns "nil" if not found}
var I: integer;
var ED: TScrollEditor;
begin
Result:=nil;
with DebugDlg.EditPageControl do
 begin
 ED:=TScrollEditor(Pages[0].Controls[0]);
 if Filename = 'Main' then begin Result:=ED; exit; end;
 for I:=1 to PageCount-1 do
	begin
	ED:=TScrollEditor(Pages[I].Controls[0]);
	if ED.Filename=Filename then begin Result:=ED; break; end;
	end
 end;
end;


function GetDebugEditor(Filename: string): TScrollEditor;
{Find editor corresponidng to filename}
{If not found, then create one}
begin
Result:=FindEditor(Filename);
if Result=nil then Result:=AddEditor(Filename);
end;


procedure ShowEditor(ED: TScrollEditor);
{Select the tabsheet that corresponds}
{to the editor to make it visible}
var TS: TTabSheet;
var PG: TPageControl;
begin
TS:=TTabSheet(ED.Parent);
PG:=TS.PageControl;
PG.ActivePage:=TS;
end;



function SetDebugEditor(Filename: string): TScrollEditor;
{Setup the current debug editor based on the filename}
begin
Result:=GetDebugEditor(Filename);
ShowEditor(Result);
end;


{------------------- Support Routines ---------------------------------------}


procedure StartTimer;
begin
DebugDlg.SubTimer.Reset;
DebugDlg.SubTimer.Start;
end;

procedure StopTimer;
begin
DebugDlg.SubTimer.Stop;
DebugDlg.SubTimer.Display;
end;


procedure ExpandI2LPanel;
var Pan,Scrn,Dlg,T: integer;
var R: TRect;
begin
with DebugDlg do
 begin
 {Use top align to freeze the Source Panel's size while other panels aren't visible}
 SourcePanel.Align:=alTop;
 {Calculate the combined height of I2L and Memory panels}
 Pan:=I2LPanel.Height+TopSplit.Height+BottomSplit.Height+MemoryPanel.Height;
 {Calculate the screen client height}
 SystemParametersInfo(SPI_GETWORKAREA,0,@R,0);
 Scrn:=R.Bottom-R.Top;
 {Calculate the height of dialog when I2L and Memory panels are visible}
 Dlg:=Pan+DebugDlg.Height;
 {Check if new size greater the screen size}
 if Dlg>Scrn then
	begin
	{Force the dialog height to screen client height}
	DebugDlg.Height:=Scrn;
	{Set each panel to take up 1/3 of the space}
	T:=DebugDlg.ClientHeight div 3;
	SourcePanel.Height:=T;
	I2LPanel.Height:=T;
	MemoryPanel.Height:=T;
	end
 else DebugDlg.Height:=DebugDlg.Height+Pan;
{Note: order is important}
 I2LPanel.Visible:=True;
 MemoryPanel.Visible:=True;
 TopSplit.Visible:=True;
 BottomSplit.Visible:=True;
 TopSplit.Top:=I2LPanel.Top-5;
 BottomSplit.Top:=MemoryPanel.Top-5;
 end;
end;


procedure ShrinkI2LPanel;
var Pan: integer;
begin
with DebugDlg do
 begin
 Width:=DebugDlg.Width;
 Height:=DebugDlg.Height;
 Pan:=I2LPanel.Height+TopSplit.Height+BottomSplit.Height+MemoryPanel.Height;
 I2LPanel.Visible:=False;
 MemoryPanel.Visible:=False;
 TopSplit.Visible:=False;
 BottomSplit.Visible:=False;
 if WindowState<>wsMaximized then DebugDlg.Height:=DebugDlg.Height-Pan;
 SourcePanel.Align:=alClient;
 end;
end;


procedure ShowI2LPanel(Enable: boolean);
{Hide or display the Low-Level I2L panel}
begin
 begin
 if Enable then ExpandI2LPanel
 else ShrinkI2LPanel;
 end;
end;


{------------------- Stack Display Handlers ---------------------------------}


procedure DisplayStackItem(S: string; Rect: TRect);
{Display the string in the grid inside the rectangle}
begin
DebugDlg.StackGrid.Canvas.TextRect(Rect,Rect.Left+2,Rect.Top+2,S);
end;


procedure DisplayStackRealItem(Inx: integer; Rect: TRect);
var D: double;
var I,J: integer;
begin
if Inx<1 then exit;
for I:=0 to IntsPerReal-1 do
	begin
	J:=(IntsPerReal-1)-I;
	PI2LWord(Integer(@D)+I*IntBytes)^:=I2LStack[Inx-J].Item;
	end;
DisplayStackItem(FLoatToStrF(D,ffFixed,18,3), Rect);
end;

procedure TDebugDlg.StackGridDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
{Handle drawing one cell in Stack Grid}
var Inx: integer;
begin
if ARow=0 then
	begin
	case ACol of
	 0: DisplayStackItem('#',Rect);
	 1: DisplayStackItem('Dec',Rect);
	 2: DisplayStackItem('Hex',Rect);
	 3: DisplayStackItem('Real',Rect);
	 end;
	end
else
	begin
	Inx:=(StackPtr-1)-(ARow-1);
	if (Inx<0) or (Inx>=StackPtr) then exit;
	case ACol of
	 0: DisplayStackItem(IntToStr(Inx),Rect);
	 1: DisplayStackItem(IntToStr(I2LStack[Inx].Item),Rect);
	 2: DisplayStackItem(IntToHexBytes(I2LStack[Inx].Item and WordMask,2),Rect);
	 3: DisplayStackRealItem(Inx, Rect);
	 end;
	end;
end;





{------------------- Memory Display Handlers ----------------------------------}

const BytesPerRow = 16;	{Specifies the number of bytes display per row}


{Saved cell values used when user hits ESC to undo changes}

var OldInx: integer;	{Last selected index in memory array}
var OldValue: Byte;	{Last selected value in memory array}


function ColRowToIndex(Col,Row: integer): integer;
{Convert Row/Column to memory/ code array index}
begin
Result:=(Row-1)*BytesPerRow+Col-1;
end;



procedure IndexToColRow(Inx: integer; var Col,Row: integer);
{Convert Index to corresponding Col and Row on memory grid}
begin
Row:=(Inx div BytesPerRow)+1;
Col:=(Inx mod BytesPerRow)+1;
end;



procedure DisplayMemItem(S: string; Rect: TRect);
{Display the string in the grid inside the rectangle}
begin
DebugDlg.MemGrid.Canvas.TextRect(Rect,Rect.Left+2,Rect.Top+2,S);
end;



procedure DrawGridCursor(Grid: TDrawGrid; Rect: TRect);
{Draw the highlight cursor for the ASCII portion of the memory display}
var CWidth,CLeft: integer;
begin
Grid.Canvas.Pen.Color:=clRed;
Grid.Canvas.Pen.Mode:=pmMergePenNot;
Grid.Canvas.Brush.Color:=clRed;
CWidth:=Grid.Canvas.TextWidth(' ');

CLeft:=Rect.Left+((Grid.Col-1)*CWidth)+3;
Grid.Canvas.Rectangle(CLeft,Rect.Top,CLeft+CWidth,Rect.Bottom);
Grid.Canvas.Pen.Mode:=pmCopy;
end;



function GetASCIIStr(Inx: integer): string;
{Get string that displays the corresponding ASCII for row of data}
var I,L: integer;
var B: byte;
begin
Result:='';
L:=Length(I2LProgram.ProgData.Code);
for I:=0 to BytesPerRow-1 do
	begin
	if (Inx+I)>=L then Result:=Result+'-'
	else
		begin
		B:=I2LProgram.ProgData.Code[Inx+I];
		if B<$20 then B:=byte('.');
		Result:=Result+char(B);
		end;
	end;
end;




function HandleColumnHeads(Col: integer): string;
{Display column headers for Memory grid}
begin
if Col=0 then Result:='#'
else if Col<=BytesPerRow then Result:=IntToHex(Col-1,2)
else Result:='ASCII';
end;




function GetMemGridItem(Col,Row: integer): string;
{Get the text to display in specified cell}
var I: integer;
begin
if (Row=0) then Result:=HandleColumnHeads(Col)
else
	begin
	if Col=0 then Result:=IntToHex((Row-1)*BytesPerRow,4)
	else if Col<=BytesPerRow then
		begin
		I:=ColRowToIndex(Col,Row);
		if I>=Length(I2LProgram.ProgData.Code) then Result:='-'
		else Result:=IntToHex(I2LProgram.ProgData.Code[I],2);
		end
	else Result:=GetASCIIStr(ColRowToIndex(1,Row));
	end;
end;




procedure TDebugDlg.MemGridDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
{Called when one cell in the memory grid is to be drawn}
begin
MemGrid.Canvas.TextRect(Rect,Rect.Left+3,Rect.Top,GetMemGridItem(ACol,ARow));
if (ARow>0) and (ACol>=(BytesPerRow+1)) and (ARow=MemGrid.Row) then DrawGridCursor(MemGrid,Rect);
end;




procedure DisplayEditStatus(Col,Row:longint);
{Display status bar info for memory grid}
var Inx: longint;
var B1,B2: byte;
var W: word;
var SW: smallint;
begin
Inx:=ColRowToIndex(Col,Row);
B1:=I2LProgram.ProgData.Code[Inx];
B2:=I2LProgram.ProgData.Code[Inx+1];
W:=B1 + Swap(B2);
SW:=B1 + Swap(B2);
DebugDlg.CursorAddDecDis.Caption:=FloatToStrF(Inx,ffNumber,18,0)+' ';
DebugDlg.CursorAddHexDis.Caption:='$'+IntToHex(Inx,4)+' ';
DebugDlg.CursorHexDis.Caption:='$'+IntToHex(B1,2)+' ';
DebugDlg.CursorDecDis.Caption:=FloatToStrF(B1,ffNumber,18,0)+' ';
DebugDlg.WordHexDis.Caption:='$'+IntToHex(W,SizeOf(TI2LWord))+' ';
DebugDlg.WordDecDis.Caption:=FloatToStrF(W,ffNumber,18,0)+' ';
DebugDlg.SignedDecDis.Caption:=FloatToStrF(SW,ffNumber,18,0)+' ';
end;



procedure TDebugDlg.MemGridSelectCell(Sender: TObject; ACol, ARow: Integer;
  var CanSelect: Boolean);
{Handle cell selection in memory grid}
begin
CanSelect:=(ACol>0) and (ACol<17);
if not CanSelect then exit;
OldInx:=ColRowToIndex(ACol,ARow);
OldValue:=I2LProgram.ProgData.Code[OldInx];
DisplayEditStatus(ACol,ARow);
MemGrid.Invalidate;
end;



procedure TDebugDlg.MemGridSetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
{Handles user-entered text in the memory grid }
{Program arrives here when the user enters a character}
var Rect: TRect;
var Inx: integer;
begin
if (ARow=0) or (ACol=0) or (Pos(' ',Value)>0) then exit;
try
Inx:=ColRowToIndex(ACol,ARow);
I2LProgram.ProgData.Code[Inx]:=StrToInt('$'+Value);
Rect:=MemGrid.CellRect(17, ARow);
MemGrid.Canvas.TextRect(Rect,Rect.Left+3,Rect.Top,GetASCIIStr(Inx));
MemGrid.Invalidate;
except end;
end;



procedure TDebugDlg.MemGridKeyPress(Sender: TObject; var Key: Char);
{Handle a key press in the edit grid}
begin
{Undo changes when user hits ESC}
if Key = ESC_CHAR then
	begin
	MemGrid.EditorMode:=False;
	I2LProgram.ProgData.Code[OldInx]:=OldValue;
	end;
end;



{------------------ Break Point Handler -------------------------------------}



procedure AddBreakItem(Filename: string; Line,PC: integer);
{Add a break point to the array}
var ED: TScrollEditor;
begin
ED:=GetDebugEditor(Filename);
SetLength(BreakArray,Length(BreakArray)+1);
BreakArray[High(BreakArray)].Line:=Line;
BreakArray[High(BreakArray)].PC:=PC;
BreakArray[High(BreakArray)].Filename:=Filename;
ED.RowMarks.AddLine('Breaks',Line,clRed);
ED.Invalidate;
end;



procedure DeleteBreakItem(Inx: integer);
{Delete the specified breakpoint from array}
var I: integer;
var ED: TScrollEditor;
begin
if (Length(BreakArray)<1) or (Inx<0) or (Inx>=Length(BreakArray)) then exit;
ED:=GetDebugEditor(BreakArray[Inx].Filename);
ED.RowMarks.DeleteLine('Breaks',BreakArray[Inx].Line);
ED.Invalidate;

for I:=Inx to Length(BreakArray)-2 do BreakArray[I]:=BreakArray[I+1];
SetLength(BreakArray,Length(BreakArray)-1);
end;



procedure ClearBreaks;
{Erase all break points}
var I: integer;
begin
for I:=High(BreakArray) downto 0 do DeleteBreakItem(I);
SetLength(BreakArray,0);
DebugDlg.BreakGrid.Invalidate;
end;



function IndexOfBreakPoint(Filename: string; Line: integer): integer;
{Locate a break point that corresponds to a line in the code}
var I: integer;
begin
Result:=-1;
for I:=0 to High(BreakArray) do
 if (BreakArray[I].Filename=Filename) and
    (BreakArray[I].Line=Line) then
	begin
	Result:=I;
	break;
	end;
end;




function AtBreakPoint(PC: integer): boolean;
{Check to see if there is a break point at the current PC}
var I: integer;
begin
Result:=True;
for I:=0 to Length(BreakArray)-1 do
 if BreakArray[I].PC=PC then exit;
Result:=False;
end;



procedure RefreshBreakpoints;
{Reprocess all breakpoints, converting their line numbers into PCs}
{You must do this to the break points after a recompile because PC may have changed}
var I,PC: integer;
var BA: TBreakArray;
begin
BA:=BreakArray;
ClearBreaks;
for I:=0 to High(BA) do
	begin
	PC:=LineNumberToPC(BA[I].Filename,BA[I].Line,ProgramStore.ProgData.BaseAddress);
	AddBreakItem(BA[I].Filename,BA[I].Line,PC)
	end;
DebugDlg.BreakGrid.Invalidate;
end;


{------------- Handle Breakpoint Grid display ---------------------------------}


procedure DisplayBreakItem(S: string; Rect: TRect);
{Display the string in the grid inside the rectangle}
begin
DebugDlg.BreakGrid.Canvas.TextRect(Rect,Rect.Left+2,Rect.Top+2,S);
end;



procedure TDebugDlg.BreakGridDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
{Handles drawing single break-point grid cell}
{Is called by the Grid itself when it needs updating.}
var Inx: integer;
begin
if ARow=0 then
	begin
	case ACol of
	 0: DisplayBreakItem('#',Rect);
	 1: DisplayBreakItem('Line',Rect);
	 2: DisplayBreakItem('PC',Rect);
	 3: DisplayBreakItem('File',Rect);
	 end;
	end
else
	begin
	Inx:=ARow-1;
	if (Inx<0) or (Inx>=Length(BreakArray)) then exit;
	case ACol of
	 0: DisplayBreakItem(IntToStr(ARow),Rect);
	 1: DisplayBreakItem(IntToStr(BreakArray[ARow-1].Line),Rect);
	 2: DisplayBreakItem(IntToHex(BreakArray[ARow-1].PC,4),Rect);
	 3: DisplayBreakItem(ExtractNamePart(BreakArray[ARow-1].Filename),Rect);
	 end;
	end;
end;

{----------------- Breakpoint Tool Button Handlers ----------------------------}


procedure TDebugDlg.SetBreakAtCursor1Click(Sender: TObject);
{Set a break point at the current cursor location}
var Line,PC,Rows: integer;
var ED: TScrollEditor;
begin
ED:=GetVisibleEditor;
Line:=ED.WorkingCursor.Position.Y;
PC:=LineNumberToPC(ED.Filename,Line,ProgramStore.ProgData.BaseAddress);
AddBreakItem(ED.Filename,Line,PC);
PageControl1.ActivePageIndex:=1;

Rows:=Length(BreakArray)+1;
if Rows<30 then Rows:=30;
BreakGrid.RowCount:=Rows+1;
if Length(BreakArray)>0 then BreakGrid.Row:=Length(BreakArray);
BreakGrid.Invalidate;
end;



procedure TDebugDlg.DeleteBreakBtnClick(Sender: TObject);
{Handle hitting the delete breakpoint button}
begin
DeleteBreakItem(BreakGrid.Row-1);
BreakGrid.Invalidate;
end;



procedure TDebugDlg.ClearBreaksBtnClick(Sender: TObject);
{Handle the clear breakpoints button}
begin
ClearBreaks;
end;



procedure TDebugDlg.BreakGridDblClick(Sender: TObject);
{If the user double clicks on the break list make sure the line is visible in the editor. }
var Inx: integer;
var P: TPoint;
var ED: TScrollEditor;
begin
Inx:=BreakGrid.Row-1;
P:=Point(0,BreakArray[Inx].Line);
ED:=SetDebugEditor(BreakArray[Inx].Filename);

ED.SetPosition(P);
ED.HighlightLine;
ED.Invalidate;
if ED.CanFocus then ED.SetFocus;
end;



{------------- Handle Watch Grid display ---------------------------------}



procedure DisplayWatchItem(S: string; Rect: TRect);
{Display the string in the grid inside the rectangle}
begin
DebugDlg.WatchGrid.Canvas.TextRect(Rect,Rect.Left+2,Rect.Top+2,S);
end;







procedure TDebugDlg.WatchGridDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
{Draw specified watch cell }
{Is called by the Grid itself when it needs updating.}
var Inx: integer;
var WI: TWatchInfo;
begin
if ARow=0 then
	begin
	case ACol of
	 0: DisplayWatchItem('#',Rect);
	 1: DisplayWatchItem('Name',Rect);
	 2: DisplayWatchItem('Value',Rect);
	 end;
	end
else
	begin
	Inx:=ARow-1;
	if (Inx<0) or (Inx>=Length(WatchArray)) then exit;
	WI:=WatchArray[ARow-1];
	case ACol of
	 0: DisplayWatchItem(IntToStr(ARow),Rect);
	 1: DisplayWatchItem(WI.VarText,Rect);
	 2:
		begin
		TravStart:=0;
		DisplayWatchItem(GetWatchValue(ARow-1),Rect);
		end;
	 end;
	end;
end;


{----------------- Routines to handle actual Debugging ---------------------}



procedure EnableToolButtons(Enable,Reset: boolean);
{Enable/disable specified tool buttons}
{The "Reset" button is handled separately}
begin
DebugDlg.RunBtn.Enabled:=Enable;
DebugDlg.StepIntoBtn.BlockClick:=not Enable;
DebugDlg.StepOverBtn.BlockClick:=not Enable;
DebugDlg.ResetBtn.Enabled:=Reset;
DebugDlg.I2LStepIntoBtn.BlockClick:=not Enable;
DebugDlg.I2LStepOverBtn.BlockClick:=not Enable;
end;




procedure ShowProgramCounter;
{Update the PC, Opcode and Heap Pointer display}
begin
DebugDlg.PCDis.Caption:='$'+IntToHex(I2LProgram.ProgCntr,IntNibbles);
DebugDlg.OpcodeDis.Caption:='$'+IntToHex(I2LProgram.GetOpcode,2);
DebugDlg.HeapDis.Caption:=IntToStr(I2LProgram.HeapPtr)+' $'+IntToHex(I2LProgram.HeapPtr,4);;
DebugDlg.StackDepthDis.Caption:=IntToStr(StackPtr);
end;



procedure HideExecuteHighlight;
{Hide the execute line highlight in the text editors}
begin
HighlightEditor.RowMarks.DeleteGroup('Execute');
HighlightEditor.Invalidate;
DebugDlg.I2LEditor.RowMarks.DeleteGroup('Execute');
DebugDlg.I2LEditor.Invalidate;
end;





procedure UpdateWatchGrid;
begin
DebugDlg.WatchGrid.Invalidate;
UpdateVariableDisplay;
end;


function GetHeapRowCount: integer;
begin
Result:=I2LProgram.HeapSize;
Result:=I2LProgram.HeapPtr-I2LProgram.HeapLow+2;
if Result<20 then Result:=25;
end;


procedure ShowExecuteHightlight;
{Show the execute line hightlight in the text editors}
var P: TPoint;
var L: integer;
begin
P.X:=SourceInfo.Column;
P.Y:=SourceInfo.Line;
OldLine:=SourceInfo.Line;
HighlightEditor:=SetDebugEditor(SourceInfo.Filename);
HighlightEditor.SetPosition(P);
HighlightEditor.RowMarks.DeleteGroup('Execute');
HighlightEditor.RowMarks.AddLine('Execute',P.Y,clNavy);
HighlightEditor.Invalidate;
if HighlightEditor.CanFocus and DebugDlg.Visible then HighlightEditor.SetFocus;
if Opcode=0 then EndOfProgram:=True;
ShowProgramCounter;
UpdateWatchGrid;
UpdateBitmapDisplay;
UpdateSystemDisplay;
UpdateStackDump;
UpdatePaletteDisplay;
L:=I2LDisasm.PCToDisasmLine(I2LProgram.ProgCntr);
DebugDlg.I2LEditor.SetPosition(Point(0,L));
DebugDlg.I2LEditor.RowMarks.DeleteGroup('Execute');
DebugDlg.I2LEditor.RowMarks.AddLine('Execute',L,clNavy);

DebugDlg.I2LEditor.Invalidate;
DebugDlg.StackGrid.Invalidate;
DebugDlg.MemGrid.Invalidate;
DebugDlg.VectorGrid.Invalidate;
end;


type TDebugState = (dsStopped,dsRunning,dsFinished);


procedure ShowDebugState(State: TDebugState);
begin
case State of
 dsStopped:
	begin
	DebugDlg.RunStateDis.Caption:='Stopped';
	DebugDlg.RunStateDis.Color:=clYellow;
	end;
 dsRunning:
	begin
	DebugDlg.RunStateDis.Caption:='Running';
	DebugDlg.RunStateDis.Color:=clLime;
	end;
 dsFinished:
	begin
	DebugDlg.RunStateDis.Caption:='Finished';
	DebugDlg.RunStateDis.Color:=clRed;
	end;
 end;
end;



procedure HandleProgramState;
{Display the current program state}
begin
ShowExecuteHightlight;
if EndOfProgram then
	begin
	FinalizeInterpreter;
	EnableToolButtons(False,True);
	ShowDebugState(dsFinished);
	end
else	begin
	EnableToolButtons(True,True);
	ShowDebugState(dsStopped);
	end;
ShowHeapData;
ShowVarsInScope(DebugDlg.SymbolGrid);
end;



function CompileAndLoadProgram: boolean;
{Handle compling and loading program for debugger }
var ErrCnt: integer;
var Disasm: string;
begin
Result:=False;
ShowProgressDlg(True);
SetProgress('Initializing',0);
try
if Form1.RunOnOff.BoxOn then
	begin
	Form1.StopBtnClick(DebugDlg);
	Application.ProcessMessages;
	end;
InitializeMessages;
Form1.MessageView.Items.Clear;
try
ChangeDefaultDir(Form1.SourceEdit.CurrentFile);
SetProgress('Compiling',25);
ErrCnt:=DoAutoCompile(Form1.SourceEdit.Editor.Text,I2LCode,IDEMessageHandler);
finally MessagePostCompile; end;
if ErrCnt>0 then
	begin
	MessageDlg('Compile Errors, Cannot Debug.',mtWarning, [mbOK], 0);
	exit;
	end;

{Main form reset}
Form1.ConsoleWnd.VGABox.Color:=clBlack;
Form1.ConsoleWnd.VGABox.Clear;
Form1.IDEPageControl.ActivePageIndex:=1;
if Form1.ConsoleWnd.CanFocus then Form1.ConsoleWnd.SetFocus;

SetProgress('Loading',50);
if not LoadI2LCode(I2LCode,ProgramStore.ProgData) then
	begin
	MessageDlg('Loader Error, Cannot Debug.',mtWarning, [mbOK], 0);
	exit;
	end;
{The disassembly must be done here because
SetProgramCode changes the program size}
SetProgress('Disassembling',75);
DisAssembleI2L(ProgramStore.ProgData.Code,Disasm);
SetProgramCode(ProgramStore);
LoadVariables;
DebugDlg.I2LEditor.Text:=Disasm;

SetProgress('Done',100);
finally ShowProgressDlg(False); end;
Result:=True;
end;



procedure InitializeDebugger;
{Reset and initialize all debugger parameters}
begin
ResetBitmapDisplay;
InitializeInterpreter(Form1.ConsoleWnd);
SourceInfo:=PCToSourceData(I2LProgram.ProgCntr,ProgramStore.ProgData.BaseAddress).Info;
ShowExecuteHightlight;
EndOfProgram:=False;
EnableToolButtons(True,True);
ShowDebugState(dsStopped);

OldLine:=-1;
end;



procedure FinalizeDebugger;
{Reset and finalize debugger state (currently unused)}
begin
FinalizeInterpreter;
ShowRunState(True);
end;


procedure SetupSymbolGrid(Grid: TStringGrid);
begin
Grid.Cells[0,0]:='#';
Grid.Cells[1,0]:='Address';
Grid.Cells[2,0]:='Variable';
Grid.Cells[3,0]:='Value Hex';
Grid.Cells[4,0]:='Value Dec';
Grid.Cells[5,0]:='Level';
Grid.Cells[6,0]:='Offset';
end;



procedure DoDebugConsole;
{Called to display and start the debugger}
begin
ClearEditors;
DebugDlg.DebugEditor.LoadFromFile(Form1.SourceEdit.CurrentFile);
DebugDlg.DebugEditor.Filename:='Main';
if not CompileAndLoadProgram then exit;
if Form1.SourceEdit.FileChange then
	begin
	ClearBreaks;
	ClearWatches;
	end
else
	begin
	RefreshVariables;
	UpdateWatchGrid;
	RefreshBreakpoints;
	end;
DebugDlg.I2LEditor.SetCursorPosition(Point(0,0));
DebugDlg.I2LEditor.ResetMarkers;
DebugDlg.DecAddSpin.Value:=I2LProgram.HeapLow;

DebugDlg.MemGrid.RowCount:=Length(I2LProgram.ProgData.Code) div BytesPerRow;
DebugDlg.MemGrid.Invalidate;

DebugDlg.Show;
DebugDlg.WindowState:=wsNormal;
InitializeDebugger;
DebugDlg.EditPageControl.ActivePageIndex:=0;
DebugDlg.DebugEditor.GotoLine(Form1.SourceEdit.Editor.WorkingCursor.Position.Y);
Form1.SourceEdit.FileChange:=False;

SetupSymbolGrid(DebugDlg.SymbolGrid);
ShowVarsInScope(DebugDlg.SymbolGrid);
end;


procedure ShowCodeState;
{Called to display and start the debugger}
begin
ClearEditors;
DebugDlg.DebugEditor.LoadFromFile(Form1.SourceEdit.CurrentFile);
DebugDlg.DebugEditor.Filename:='Main';
//if not CompileAndLoadProgram then exit;
if Form1.SourceEdit.FileChange then
	begin
	ClearBreaks;
	ClearWatches;
	end
else
	begin
	RefreshVariables;
	UpdateWatchGrid;
	RefreshBreakpoints;
	end;
DebugDlg.MemGrid.RowCount:=Length(I2LProgram.ProgData.Code) div BytesPerRow;
DebugDlg.MemGrid.Invalidate;
DebugDlg.Show;
DebugDlg.DebugEditor.GotoLine(Form1.SourceEdit.Editor.WorkingCursor.Position.Y);
Form1.SourceEdit.FileChange:=False;
end;


procedure StepInto;
{step forward one line of code,}
{ following subroutine calls}
begin
repeat
	begin
	InterpretLoop(True);
	SourceInfo:=PCToSourceData(I2LProgram.ProgCntr,ProgramStore.ProgData.BaseAddress).Info;
	end
until (OldLine<>SourceInfo.Line) or (Opcode=0);	{Loop until the line number changes}
{Update display}
Form1.ConsoleWnd.VGABox.Repaint;
end;




procedure StepOverLine;
{Step forward one line of code,}
{ executing subroutines at full speed}
var CallCode,RetCode,OC: byte;
var Nesting,OldLine: integer;

	procedure StepOverCall;
	{Step over all nested  subroutines }
	begin
	{Step until a subroutine call is found on this line}
	while true do
		begin
		OC:=I2LProgram.GetOpcode;
		if OC=0 then begin Opcode:=0; exit; end;
		if OC in [$05,$26] then break;
		InterpretLoop(True);
		SourceInfo:=PCToSourceData(I2LProgram.ProgCntr,ProgramStore.ProgData.BaseAddress).Info;
		if SourceInfo.Line<>OldLine then exit;
		Application.ProcessMessages;
		if DebugAbort then exit;
		end;
	{Now save the corresponding call and return codes}
	OC:=I2LProgram.GetOpcode;
	case OC of
	 $05:
		begin
		CallCode:=$05;
		RetCode:=$06;
		end;
	 $26:
		begin
		CallCode:=$26;
		RetCode:=$27;
		end;
	 else begin StepInto; exit; end;
	 end;
	{Now follow all subroutines, keeping track of the nesting}
	{We count the nesting of the same type of subroutines }
	{because they are the only one we could confuse with ours}
	{Stop when the nesting reaches zero}
	Nesting:=0;
	repeat
		begin
		InterpretLoop(True);
		SourceInfo:=PCToSourceData(I2LProgram.ProgCntr,ProgramStore.ProgData.BaseAddress).Info;
		if Opcode=Callcode then Inc(Nesting)
		else if Opcode=RetCode then Dec(Nesting);
		if DebugAbort then exit;
		end
	until (Nesting<1) or (Opcode=0);
	end;

begin
{Look for subroutine call on same line as the highlight}
{That handles both optimized and non-optimized procedures}
DebugAbort:=False;
OldLine:=SourceInfo.Line;
try
Form1.ConsoleWnd.RefreshTimer.Enabled:=True;
repeat
	begin
	StepOverCall;
	if DebugAbort then exit;
	end
until (SourceInfo.Line<>OldLine) or (Opcode=0);
finally
 Form1.ConsoleWnd.RefreshTimer.Enabled:=False;
 end;
SourceInfo:=PCToSourceData(I2LProgram.ProgCntr,ProgramStore.ProgData.BaseAddress).Info;
Form1.ConsoleWnd.VGABox.Repaint;
end;


{----------------- Tool bar button event handlers -----------------------------}



procedure TDebugDlg.StepIntoBtnClick(Sender: TObject);
{Handle step-into button press}
begin
if EndOfProgram then exit;
HideExecuteHighlight;
EnableToolButtons(False,False);
ShowDebugState(dsRunning);
try
StartTimer;
try
StepInto;
finally StopTimer; end;
finally HandleProgramState; end;
end;



procedure TDebugDlg.RunBtnClick(Sender: TObject);
{Handle Run-Button Press}
{Loop until: abort, program end or break point}
begin
if EndOfProgram then exit;
DebugAbort:=False;
HideExecuteHighlight;
EnableToolButtons(False,False);
ShowDebugState(dsRunning);
try
Form1.ConsoleWnd.RefreshTimer.Enabled:=True;
if Form1.ConsoleWnd.CanFocus then Form1.ConsoleWnd.SetFocus;
StartTimer;
try
repeat
	begin
	InterpretLoop(True);
	if AtBreakPoint(I2LProgram.ProgCntr) then break;
	if DebugAbort then break;
	end
until (Opcode=0);
finally StopTimer; end;
Form1.ConsoleWnd.VGABox.Repaint;

finally
 Form1.ConsoleWnd.RefreshTimer.Enabled:=False;
 SourceInfo:=PCToSourceData(I2LProgram.ProgCntr,ProgramStore.ProgData.BaseAddress).Info;
 HandleProgramState;
 end;
end;




procedure TDebugDlg.StepOverBtnClick(Sender: TObject);
{Handle step-over button press}
begin
if EndOfProgram then exit;
HideExecuteHighlight;
EnableToolButtons(False,False);
ShowDebugState(dsRunning);
try
StartTimer;
try
StepOverLine;
finally StopTimer; end;
finally HandleProgramState; end;
end;



procedure TDebugDlg.ResetBtnClick(Sender: TObject);
{Handle reset-button press}
begin
FinalizeInterpreter;
LoadI2LCode(I2LCode,ProgramStore.ProgData);
SetProgramCode(ProgramStore);
LoadVariables;
InitializeDebugger;
ShowVarsInScope(DebugDlg.SymbolGrid);
end;



procedure TDebugDlg.SearchBtnClick(Sender: TObject);
{Activate search dialog}
begin
FindDialog1.Execute;
end;



procedure TDebugDlg.FindDialog1Find(Sender: TObject);
{Respond to search dialog events}
var Target: string;
var Editor: TScrollEditor;
begin
Editor:=GetVisibleEditor;

Target:=FindDialog1.FindText;
Editor.Searcher.WholeWordMode:=(FindDialog1.Options*[frWholeWord])=[frWholeWord];
Editor.Searcher.IgnoreCase:=not ((FindDialog1.Options * [frMatchCase]) = [frMatchCase]);
if (FindDialog1.Options * [frDown]) = [frDown] then Editor.ForwardSearch(Target)
else Editor.BackwardSearch(Target);
Editor.Invalidate;
end;



procedure TDebugDlg.ExePointBtnClick(Sender: TObject);
{Scroll editor to insure the execution point is visible}
var P: TPoint;
var ED: TScrollEditor;
begin
P.X:=SourceInfo.Column;
P.Y:=SourceInfo.Line;
ED:=SetDebugEditor(SourceInfo.Filename);
ED.SetPosition(P);
ShowEditor(ED);
end;



procedure TDebugDlg.StopBtnClick(Sender: TObject);
{Abort the program}
begin
DebugAbort:=True;
GlobalConsole.InjectKeystroke(CtrlC);
end;



{------------------ Watch Tool Button handlers ------------------------------}


procedure TDebugDlg.VariableBtnClick(Sender: TObject);
{Display all variables in the program}
begin
DoVariableDlg(True);
end;



procedure TDebugDlg.WatchPropBtnClick(Sender: TObject);
{Set properties of selected watch}
var Inx: integer;
begin
Inx:=WatchGrid.Row-1;
if (Inx<0) or (Inx>High(WatchArray)) then
	begin
	MessageDlg('No Watch Selected.',mtWarning, [mbOK], 0);
	exit;
	end;
DoWatchFormat(WatchArray[Inx]);
end;


procedure TDebugDlg.MoveUpBtnClick(Sender: TObject);
begin
MoveWatchItem(WatchGrid.Row-1, False);
end;


procedure TDebugDlg.MoveDnBtnClick(Sender: TObject);
begin
MoveWatchItem(WatchGrid.Row-1, True);
end;



procedure TDebugDlg.DeleteWatchBtnClick(Sender: TObject);
{Delete selected watch}
begin
DeleteWatchItem(WatchGrid.Row-1);
UpdateWatchGrid;
end;



procedure TDebugDlg.ClearWatchBtnClick(Sender: TObject);
{Clear All watches}
var R: word;
begin
R:=MessageDlg('About to delete all watches.'+CRLF_Char+'Are you sure?', mtConfirmation, [mbYes, mbNo, mbCancel], 0);
if R=mrYes then ClearWatches;
end;



procedure TDebugDlg.ModifyBtnClick(Sender: TObject);
{Modify the specified variable's value}
var Inx: integer;
var VI: TVariableInfo;
var Format: TVarFormat;
begin
Inx:=WatchGrid.Row-1;
if (Inx<0) or (Inx>High(WatchArray)) then
	begin
	MessageDlg('No Watch Selected.',mtWarning, [mbOK], 0);
	exit;
	end;
if LookupVariable(WatchArray[Inx].VarText,WatchArray[Inx].Filename,WatchArray[Inx].Line,VI)=lrFound then
	begin
	if WatchArray[Inx].CustomFormat then Format:=WatchArray[Inx].UserFormat else Format:=VI.DefFormat;
	DoModifyVariable(VI,Format);
	end;
UpdateWatchGrid;
end;



procedure TDebugDlg.SetWatchAtCurosr1Click(Sender: TObject);
{Set watch at the current cursor position}
var VarName: string;
var ED: TScrollEditor;
var P: TPoint;
var Rows: integer;
begin
ED:=GetVisibleEditor;
P:=ED.WorkingCursor.Position;
VarName:=ED.GetHighlightedText;
if VarName='' then VarName:=ED.GetNearestWord;
SetWatchItem(VarName,ED.Filename,P.Y+1);

Rows:=Length(WatchArray)+1;
if Rows<30 then Rows:=30;
DebugDlg.WatchGrid.RowCount:=Rows+1;

if Length(WatchArray)>0 then WatchGrid.Row:=Length(WatchArray);
UpdateWatchGrid;
PageControl1.ActivePageIndex:=0;
end;






procedure TDebugDlg.BitmapBtnClick(Sender: TObject);
{Display the current watch as a handle to a bitmap}
var Inx: integer;
var VI: TVariableInfo;
begin
Inx:=WatchGrid.Row-1;
if (Inx<0) or (Inx>High(WatchArray)) then
	begin
	MessageDlg('No Watch Selected.',mtWarning, [mbOK], 0);
	exit;
	end;
if LookupVariable(WatchArray[Inx].VarText,WatchArray[Inx].Filename,WatchArray[Inx].Line,VI)=lrFound then
ShowBitmap(VI);
end;




procedure TDebugDlg.WatchGridDblClick(Sender: TObject);
{Move to the declaration of a variable if you double click on a watch variable}
var Inx: integer;
var P: TPoint;
var ED: TScrollEditor;
var VI: TVariableInfo;
begin
Inx:=WatchGrid.Row-1;
if (Inx<0) or (Inx>High(WatchArray)) then exit;
if LookupVariable(WatchArray[Inx].VarText,WatchArray[Inx].Filename,WatchArray[Inx].Line,VI)<>lrFound then exit;

P:=Point(0,VI.DeclareLine);
ED:=SetDebugEditor(VI.Filename);

ED.SetPosition(P);
ED.HighlightLine;
ED.Invalidate;
if ED.CanFocus then ED.SetFocus;
end;




procedure TDebugDlg.OpenFileatCursor1Click(Sender: TObject);
var Filename: string;
var ED: TScrollEditor;
begin
ED:=GetVisibleEditor;
Filename:=GetFileAtCursor(ED);
SetDebugEditor(Filename);
end;



{----------------- Debug Editor Envent Handlers ------------------------------}

var OldIdent: string;	{Keeps track of the last identify whose value was displayed}

function GetHintPos(ED: TScrollEditor; X,Y: integer): TPoint;
var P1,P2: TPoint;
var TH,TW: double;
begin
ED.ScaleCursorPos(X,Y);
TH:=ED.Canvas.TextHeight('M') * ED.Scale;
TW:=ED.Canvas.TextWidth('M') * ED.Scale;

P1:=ED.ScreenToCursor(0,0);
P2:=ED.ScreenToCursor(X,Y);
Result.X:=Trunc(((P2.X - P1.X)+3) * TW);
Result.Y:=Trunc(((P2.Y - P1.Y)+1) * TH);
end;


procedure TDebugDlg.DebugEditorMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
{Display the value of variables if you mouse over them}
var P,P2: TPoint;
var X1,Y1,Line: integer;
var VS,S: string;
var VI: TVariableInfo;
var ED: TScrollEditor;
var R: TLookupResult;
begin
if EndOfProgram then exit;
X1:=X; Y1:=Y;
ED:=TScrollEditor(Sender);
ED.ScaleCursorPos(X1,Y1);
P:=ED.ScreenToBufferPos(X1,Y1);
VS:=GetIdentAndSubsRL(ED,P);
Line:=P.Y+1;
R:=LookupVariable(VS,ED.Filename,Line,VI);
if R=lrNoIdent then
	begin
	GlobalHinter.KillHint;
	OldIdent:='';
	end
else if R=lrFound then
	begin
	if (VS=OldIdent) then exit;
	GlobalHinter.KillHint;
	VI.DefFormat.RealFormat:=MouseRealFormat;
	VI.DefFormat.Digits:=MouseDigits;
	TravStart:=0;
 	S:=GetWatchString(VI,VI.DefFormat,Line);
	P2:=GetHintPos(ED,X,Y);
	GlobalHinter.ShowHint(ED,P2.X,P2.Y,S,60000);
	OldIdent:=VS;
	end;
end;



procedure TDebugDlg.DebugEditorMouseLeave(Sender: TObject);
begin
GlobalHinter.KillHint;
OldIdent:='';
end;




procedure TDebugDlg.DebugEditorChange(Sender: TObject);
{Update line number display}
var ED: TScrollEditor;
begin
ED:=GetVisibleEditor;
LineDis.Caption:=IntToStr(ED.WorkingCursor.Position.Y);
end;



procedure TDebugDlg.DebugEditorMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{Insert a break point if the mouse is clicked within the left gutter}
var P: TPoint;
var PC,Inx: integer;
var ED: TScrollEditor;
begin
ED:=TScrollEditor(Sender);
if X>ED.GutterSize then exit;
ED.ScaleCursorPos(X,Y);
P:=ED.ScreenToCursor(X,Y);
Inx:=IndexOfBreakPoint(ED.Filename,P.Y);
if Inx>-1 then DeleteBreakItem(Inx)
else
	begin
	PC:=LineNumberToPC(ED.Filename,P.Y,ProgramStore.ProgData.BaseAddress);
	AddBreakItem(ED.Filename,P.Y,PC);
	end;
BreakGrid.Invalidate;
end;

{------------------------------------------------------------------------------}



const FPUHeader: array [0..13] of string =('BF','C3','ST','C2','C1','C0','ES','SF','PE','UE','OE','ZE','DE','IE');

procedure ShowFPUHeader;
var I: integer;
begin
for I:=0 to High(FPUHeader) do
 DebugDlg.FPUGrid.Cells[0,I]:=FPUHeader[I];
end;



procedure ShowFPUFlags;
var Status: Word;
begin
Status:=Get8087Status(False);
DebugDlg.FPUGrid.Cells[1,0]:=PickString(IsBitSet(Status,$8000),'1','0');
DebugDlg.FPUGrid.Cells[1,1]:=PickString(IsBitSet(Status,$4000),'1','0');
DebugDlg.FPUGrid.Cells[1,2]:=IntToStr((Status and $3800) shr 11);
DebugDlg.FPUGrid.Cells[1,3]:=PickString(IsBitSet(Status,$0400),'1','0');
DebugDlg.FPUGrid.Cells[1,4]:=PickString(IsBitSet(Status,$0200),'1','0');
DebugDlg.FPUGrid.Cells[1,5]:=PickString(IsBitSet(Status,$0100),'1','0');
DebugDlg.FPUGrid.Cells[1,6]:=PickString(IsBitSet(Status,$0080),'1','0');
DebugDlg.FPUGrid.Cells[1,7]:=PickString(IsBitSet(Status,$0040),'1','0');
DebugDlg.FPUGrid.Cells[1,8]:=PickString(IsBitSet(Status,$0020),'1','0');
DebugDlg.FPUGrid.Cells[1,9]:=PickString(IsBitSet(Status,$0010),'1','0');
DebugDlg.FPUGrid.Cells[1,10]:=PickString(IsBitSet(Status,$0008),'1','0');
DebugDlg.FPUGrid.Cells[1,11]:=PickString(IsBitSet(Status,$0004),'1','0');
DebugDlg.FPUGrid.Cells[1,12]:=PickString(IsBitSet(Status,$0002),'1','0');
DebugDlg.FPUGrid.Cells[1,13]:=PickString(IsBitSet(Status,$0001),'1','0');
end;


{------------------------------------------------------------------------------}

procedure TDebugDlg.FormClose(Sender: TObject; var Action: TCloseAction);
begin
GlobalHinter.KillHint;
FinalizeInterpreter;
end;



procedure TDebugDlg.FormCreate(Sender: TObject);
begin
ShowI2LPanel(False);
PageControl1.ActivePageIndex:=0;
MemPageControl.ActivePageIndex:=0;
ShowFPUHeader;
DebugDlg.StackGrid.RowCount:=MaxStackSize+1;
MouseDigits:=5;
MouseRealFormat:=rfGeneral;
end;


procedure TDebugDlg.FormHide(Sender: TObject);
begin
DebugAbort:=True;
end;


{------------------------------------------------------------------------------}

function InDebugMode: boolean;
begin
Result:=DebugDlg.Visible;
if Result then MessageDlg('In debug mode. Close debugger to compile.', mtWarning, [mbOK], 0);
end;





procedure TDebugDlg.I2LEditorChange(Sender: TObject);
begin
I2LLineDis.Caption:=IntToStr(I2LEditor.WorkingCursor.Position.Y);
ShowFPUFlags;
end;


procedure TDebugDlg.I2LExePointBtnClick(Sender: TObject);
var P: TPoint;
begin
P.X:=0;
P.Y:=I2LDisasm.PCToDisasmLine(I2LProgram.ProgCntr);
DebugDlg.I2LEditor.SetPosition(P);
end;




procedure I2LStepInto;
begin
InterpretLoop(True);
SourceInfo:=PCToSourceData(I2LProgram.ProgCntr,ProgramStore.ProgData.BaseAddress).Info;
Form1.ConsoleWnd.VGABox.Repaint;
end;




procedure I2LStepOverLine;
var CallCode,RetCode,OC: byte;
var Nesting: integer;
begin
{Look for subroutine call on same line as the highlight}
{That handles both optimized and non-optimized procedures}
DebugAbort:=False;
Form1.ConsoleWnd.RefreshTimer.Enabled:=True;
try
Application.ProcessMessages;
if DebugAbort then exit;
OC:=I2LProgram.GetOpcode;
if not (OC in [$05,$26]) then
	begin
	InterpretLoop(True);
	SourceInfo:=PCToSourceData(I2LProgram.ProgCntr,ProgramStore.ProgData.BaseAddress).Info;
	exit;
	end;
case OC of
 $00: exit;
 $05:
	begin
	CallCode:=$05;
	RetCode:=$06;
	end;
 $26:
	begin
	CallCode:=$26;
	RetCode:=$27;
	end;
 else begin I2LStepInto; exit; end;
 end;
Nesting:=0;
repeat
	begin
	InterpretLoop(True);
	SourceInfo:=PCToSourceData(I2LProgram.ProgCntr,ProgramStore.ProgData.BaseAddress).Info;
	if Opcode=Callcode then Inc(Nesting)
	else if Opcode=RetCode then Dec(Nesting);
	if DebugAbort then exit;
	end
until (Nesting<1) or (Opcode=0);
finally
 Form1.ConsoleWnd.RefreshTimer.Enabled:=False;
 end;
SourceInfo:=PCToSourceData(I2LProgram.ProgCntr,ProgramStore.ProgData.BaseAddress).Info;
Form1.ConsoleWnd.VGABox.Repaint;
end;





procedure TDebugDlg.I2LStepIntoBtnClick(Sender: TObject);
begin
if EndOfProgram then exit;
HideExecuteHighlight;
EnableToolButtons(False,False);
ShowDebugState(dsRunning);
try
StartTimer;
try
I2LStepInto;
finally StopTimer; end;
finally HandleProgramState; end;
end;




procedure TDebugDlg.I2LStepOverBtnClick(Sender: TObject);
begin
if EndOfProgram then exit;
HideExecuteHighlight;
EnableToolButtons(False,False);
ShowDebugState(dsRunning);
try
StartTimer;
try
I2LStepOverLine;
finally StopTimer; end;
finally HandleProgramState; end;
end;




procedure TDebugDlg.I2LCheckClick(Sender: TObject);
begin
ShowI2LPanel(I2LCheck.Checked);
end;


procedure GotoMemAddress(Add: integer);
var Col,Row: integer;
begin
IndexToColRow(Add,Col,Row);
DebugDlg.MemGrid.Col:=Col;
DebugDlg.MemGrid.Row:=Row;
DebugDlg.MemGrid.Invalidate;
end;




procedure TDebugDlg.Base1Click(Sender: TObject);
begin
if MemPageControl.ActivePageIndex=0 then GotoMemAddress(0)
else DecAddSpin.Value:=0;
end;


procedure TDebugDlg.LocalMemory1Click(Sender: TObject);
begin
if MemPageControl.ActivePageIndex=0 then GotoMemAddress(I2LProgram.LocalLow)
else DecAddSpin.Value:=I2LProgram.LocalLow;
end;


procedure TDebugDlg.HeapStart1Click(Sender: TObject);
begin
if MemPageControl.ActivePageIndex=0 then GotoMemAddress(I2LProgram.HeapLow)
else DecAddSpin.Value:=I2LProgram.HeapLow;
end;


procedure TDebugDlg.MemGridMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var ACol,ARow: longint;
var Width,NewCol,DX: integer;
var R: TRect;
begin
MemGrid.MouseToCell(X,Y,ACol,ARow);
if (ARow>0) and (ACol=(BytesPerRow+1)) then
	begin
	Width:=MemGrid.Canvas.TextWidth(' ');
	R:=MemGrid.CellRect(ACol, ARow);
	DX:=X-R.Left-3;
	NewCol:=(DX div Width)+1;
	if NewCol>BytesPerRow then NewCol:=BytesPerRow;
	MemGrid.Col:=NewCol;
	MemGrid.Row:=ARow;
	end;
MemGrid.Invalidate;
end;


procedure TDebugDlg.OpenBtnClick(Sender: TObject);
begin
if SaveDialog1.Execute then
	begin
	SetDebugEditor(OpenDialog1.Filename);
	end;
end;


procedure TDebugDlg.RefreshBtnClick(Sender: TObject);
var Old: boolean;
begin
Old:=GlobalConsole.VGABox.BlockPaint;
GlobalConsole.VGABox.BlockPaint:=False;
GlobalConsole.VGABox.Repaint;
GlobalConsole.VGABox.BlockPaint:=Old;
end;



procedure TDebugDlg.SystemBtnClick(Sender: TObject);
begin
ShowSystemDlg;
end;


procedure TDebugDlg.NewWatchBtnClick(Sender: TObject);
var VarName: string;
var ED: TScrollEditor;
var Inx: integer;
var P: TPoint;
begin
ED:=GetVisibleEditor;
P:=ED.WorkingCursor.Position;
VarName:='Watch';
SetWatchItem(VarName,ED.Filename,P.Y+1);
if Length(WatchArray)>0 then WatchGrid.Row:=Length(WatchArray);
UpdateWatchGrid;
PageControl1.ActivePageIndex:=0;
Inx:=WatchGrid.Row-1;
DoWatchFormat(WatchArray[Inx]);
end;


procedure TDebugDlg.OpenFileBtnClick(Sender: TObject);
var S: string;
begin
S:=Form1.SourceEdit.CurrentFile;
if S='' then S:='DebugInfo.dbg' else S:=ChangeFileExt(S,'.dbg');
OpenDialog2.Filename:=S;
if OpenDialog2.Execute then
	begin
	LoadXMLDebugInfo(OpenDialog2.Filename);
	HeapGrid.Invalidate;
	end;
end;



procedure TDebugDlg.SaveFileBtnClick(Sender: TObject);
var S: string;
begin
S:=Form1.SourceEdit.CurrentFile;
if S='' then S:='DebugInfo.dbg' else S:=ChangeFileExt(S,'.dbg');
SaveDialog1.Filename:=S;
if SaveDialog1.Execute then
	begin
	SaveXMLDebugInfo(SaveDialog1.Filename);
	end;
end;



procedure TDebugDlg.CopyBtnClick(Sender: TObject);
var I: integer;
var WI: TWatchInfo;
var S: string;
begin
TravStart:=0;
for I:=0 to Length(WatchArray)-1 do
	begin
	WI:=WatchArray[I];
	S:=S+WI.VarText+Tab_Char+GetWatchValue(I);
	S:=S+CRLF_Char;
	end;
ClipBoard.Open;
ClipBoard.AsText:=S;
ClipBoard.Close;
end;

procedure TDebugDlg.Help1BtnClick(Sender: TObject);
begin
Application.HelpCommand(HELP_CONTEXT, 15);
end;



procedure TDebugDlg.ConfigBtnClick(Sender: TObject);
begin
ShowDebugConfigDlg;
end;



procedure TDebugDlg.ExpandedDisplayBtnClick(Sender: TObject);
begin
ExpandedDisDlg.Show;
end;

procedure TDebugDlg.WatchGridClick(Sender: TObject);
begin
UpdateVariableDisplay;
end;


procedure TDebugDlg.VectorGridDrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
{Called when one cell in the memory grid is to be drawn}
var Inx: integer;
var S: string;
begin
Inx:=ARow - 1;
if ARow = 0 then
	begin
	case ACol of
	 0: S:='#';
	 1: S:='Vector';
	 end;
	end
else
	begin
	case ACol of
	 0: S:=IntToStr(Inx);
	 1: S:=IntToHex(DisplayVector[Inx],IntNibbles);
	 end;
	end;
VectorGrid.Canvas.TextRect(Rect,Rect.Left+3,Rect.Top,S);
end;

{===============================================================================}


procedure TDebugDlg.HeapGridDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
begin
DrawHeapGrid(ACol, ARow, Rect, State);
end;



procedure TDebugDlg.InsertHeapBtnClick(Sender: TObject);
begin
AddHeapInfo(DecAddSpin.Value, TDataType(TypeRadio.ItemIndex));
end;

procedure TDebugDlg.DeleteHeapBtnClick(Sender: TObject);
var Inx: integer;
begin
Inx:=HeapGrid.Row-1;
DeleteHeapItem(Inx);
end;

procedure TDebugDlg.ClearHeapBtnClick(Sender: TObject);
begin
if MessageDlg('About to delete all times?',mtWarning, [mbYes, mbNo], 0)<>mrYes then exit;
ClearHeapInfo;
end;



procedure TDebugDlg.DecAddSpinChange(Sender: TObject);
begin
HexAddSpin.NoEventValue:=DecAddSpin.Value;
SetHeapAddress(HeapGrid.Row-1,DecAddSpin.Value);
HeapGrid.Invalidate;
end;


procedure TDebugDlg.HexAddSpinChange(Sender: TObject);
begin
DecAddSpin.NoEventValue:=HexAddSpin.Value;
SetHeapAddress(HeapGrid.Row-1,DecAddSpin.Value);
HeapGrid.Invalidate;
end;



procedure TDebugDlg.HeapGridSelectCell(Sender: TObject; ACol,
  ARow: Integer; var CanSelect: Boolean);
var Inx: integer;
begin
Inx:=ARow-1;
if Inx>High(HeapInfoArray) then exit;
DecAddSpin.NoEventValue:=HeapInfoArray[Inx].Address;
HexAddSpin.NoEventValue:=HeapInfoArray[Inx].Address;
TypeRadio.NoEventItemIndex:=Integer(HeapInfoArray[Inx].DataType);
IndirectChk.NoEventChecked:=HeapInfoArray[Inx].Indirect;
if ACol = 1 then
	begin
	HeapGrid.Options:=HeapGrid.Options + [goEditing];
	HeapGrid.Options:=HeapGrid.Options - [goRowSelect];
	end
else
	begin
	HeapGrid.Options:=HeapGrid.Options - [goEditing];
	HeapGrid.Options:=HeapGrid.Options + [goRowSelect];
	end;
HeapGrid.Invalidate;
end;



procedure TDebugDlg.TypeRadioClick(Sender: TObject);
var Inx: integer;
begin
Inx:=HeapGrid.Row-1;
if Inx>High(HeapInfoArray) then exit;
HeapInfoArray[Inx].DataType:=TDataType(TypeRadio.ItemIndex);
HeapGrid.Invalidate;
end;


procedure TDebugDlg.IndirectChkClick(Sender: TObject);
var Inx: integer;
begin
Inx:=HeapGrid.Row-1;
if Inx>High(HeapInfoArray) then exit;
HeapInfoArray[Inx].Indirect:=IndirectChk.Checked;
HeapGrid.Invalidate;
end;


procedure TDebugDlg.HeapGridGetEditText(Sender: TObject; ACol,
  ARow: Integer; var Value: String);
var Inx: integer;
begin
Inx:=HeapGrid.Row-1;
if Inx>High(HeapInfoArray) then exit;
Value:=HeapInfoArray[Inx].Name;
end;


procedure TDebugDlg.HeapGridSetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
var Inx: integer;
begin
Inx:=HeapGrid.Row-1;
if Inx>High(HeapInfoArray) then exit;
HeapInfoArray[Inx].Indirect:=IndirectChk.Checked;
HeapInfoArray[Inx].Name:=Value;
HeapGrid.Invalidate;
end;


procedure TDebugDlg.HeapDownBtnClick(Sender: TObject);
begin
MoveHeapItem(HeapGrid.Row-1, True);
end;



procedure TDebugDlg.HeapUpBtnClick(Sender: TObject);
begin
MoveHeapItem(HeapGrid.Row-1, False);
end;





procedure TDebugDlg.VectorGridDblClick(Sender: TObject);
var Inx: integer;
begin
Inx:=VectorGrid.Row-1;
if (Inx<0) or (Inx>High(DisplayVector)) then exit;
if MemPageControl.ActivePageIndex=0 then GotoMemAddress(DisplayVector[Inx])
else DecAddSpin.Value:=DisplayVector[Inx];
end;

{--------------------------------------------------}

procedure SetWatchDefaults(var WI: TWatchInfo);
begin
WI.CustomFormat:=False;
WI.UserFormat.DisplayType:=dsInteger;
WI.UserFormat.Digits:=5;
WI.UserFormat.Radix:=nrDecimal;
WI.UserFormat.RealFormat:=rfGeneral;
WI.UserFormat.ForcedArray:=False;
SetLength(WI.UserFormat.DisplayDims,0);
end;

procedure TDebugDlg.Copy1Click(Sender: TObject);
begin
CopyStringGrid(SymbolGrid);
end;

initialization
finalization
end.
