unit IDEFileProperties;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, ComCtrls, Menus, CodeEditor, DSupport;

type
  TDetailsDlg = class(TForm)
    CancelBtn: TButton;
    PageControl1: TPageControl;
    TabSheet3: TTabSheet;
    GroupBox2: TGroupBox;
    Panel3: TPanel;
    CreateDateDis: TPanel;
    Panel7: TPanel;
    WriteDateDis: TPanel;
    Panel11: TPanel;
    FilesizeDis: TPanel;
    Panel16: TPanel;
    AccessDateDis: TPanel;
    Label2: TLabel;
    FilenameEdit: TEdit;
    BitBtn1: TBitBtn;
    procedure CancelBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var DetailsDlg: TDetailsDlg;

procedure DisplayFileProperties(var Editor: TCodeEditor);

implementation



{$R *.DFM}



{------------------------------------------------------------------------------}

type TFileDates = record
 CreateDate,AccessDate,WriteDate: TFileTime;
 end;

type TFileType = (ftUnknown,ftFile,ftFolder,ftLink);


type TFileInfo = record
 Filename: string;
 FileDates: TFileDates;
 FileType: TFileType;
 FileSize: Int64;
 end;




function GetFileType(SearchRecord: TSearchRec): TFileType;
begin
if (SearchRecord.Name='.') or (SearchRecord.Name='..') then Result:=ftLink
else if (SearchRecord.Attr and faDirectory)<>0 then Result:=ftFolder
else Result:=ftFile;
end;



procedure GetFileInfo(FileName: string; var FileInfo: TFileInfo);
var SearchRecord: TSearchRec;
var FileAttrs: Integer;
begin
if FindFirst(Filename, FileAttrs, SearchRecord) = 0 then
	begin
	FileInfo.FileType:=GetFileType(SearchRecord);
	FileInfo.FileDates.CreateDate:=SearchRecord.FindData.ftCreationTime;
	FileInfo.FileDates.AccessDate:=SearchRecord.FindData.ftLastAccessTime;
	FileInfo.FileDates.WriteDate:=SearchRecord.FindData.ftLastWriteTime;
	FileInfo.FileSize:=SearchRecord.FindData.nFileSizeLow + (SearchRecord.FindData.nFileSizeHigh shl 32);
	FindClose(SearchRecord);
	end
else FileInfo.FileType:=ftUnknown;
end;




function GetFileDateStr(FileDate: TFileTime): string;
var ST: TSystemTime;
begin
FileTimeToSystemTime(FileDate,ST);
Result:=PadInteger(ST.wMonth,2)+'/'+PadInteger(ST.wDay,2)+'/'+IntToStr(ST.wYear);
Result:=Result+':'+PadInteger(ST.wHour,2)+':'+PadInteger(ST.wMinute,2)+':'+PadInteger(ST.wSecond,2);
end;



procedure DisplayFileInfo(Filename: string);
var FileInfo: TFileInfo;
begin
if not FileExists(Filename) then exit;
GetFileInfo(Filename,FileInfo);
DetailsDlg.CreateDateDis.Caption:=GetFileDateStr(FileInfo.FileDates.CreateDate);
DetailsDlg.AccessDateDis.Caption:=GetFileDateStr(FileInfo.FileDates.AccessDate);
DetailsDlg.WriteDateDis.Caption:=GetFileDateStr(FileInfo.FileDates.WriteDate);
DetailsDlg.FilesizeDis.Caption:=FloatToStrF(FileInfo.FileSize,ffNumber,18,0);
end;



procedure DisplayFileProperties(var Editor: TCodeEditor);
var Filename: string;
begin
Filename:=ExpandFileName(Editor.CurrentFile);
DetailsDlg.FilenameEdit.Text:=Filename;
DisplayFileInfo(Filename);
DetailsDlg.Show;
end;



procedure TDetailsDlg.CancelBtnClick(Sender: TObject);
begin
Close;
end;



end.
