unit IDEI2LDisasm;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, 
  Buttons, ExtCtrls, ComCtrls,Dialogs,DSupport,I2LDisasm, I2LDataTypes;

type
  TI2LDisasmDlg = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Label2: TLabel;
    I2LMemo: TMemo;
    TabSheet2: TTabSheet;
    DisAsmMemo: TMemo;
    TabSheet3: TTabSheet;
    CodeMapMemo: TMemo;
    Panel9: TPanel;
    CodeDataChk: TCheckBox;
    Button1: TButton;
    Panel1: TPanel;
    CancelBtn: TButton;
    SourceChk: TCheckBox;
    DisassembleChk: TCheckBox;
    BitBtn1: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  I2LDisasmDlg: TI2LDisasmDlg;

procedure ShowI2LDlg;
procedure DisplayI2L(I2LHexBinary: string; I2LBinary: TI2LProgram);

implementation

uses IDEDebugger, EBXMain, IDECompileMessages, XPLCompiler, I2LLoader,
     IDEGlobal, IDEStruncts;


{$R *.dfm}



procedure ShowI2LDlg;
begin
I2LDisasmDlg.Show;
end;


procedure DisplayI2L(I2LHexBinary: string; I2LBinary: TI2LProgram);
var Disasm: string;
begin
I2LDisasmDlg.I2LMemo.Text:=I2LHexBinary;
if I2LBinary.Loaded then
	begin
	if I2LDisasmDlg.DisassembleChk.Checked then
		begin
		if I2LDisasmDlg.SourceChk.Checked then DisAsmI2LWithSource(I2LBinary,Form1.SourceEdit.Editor.Text,Disasm)
		else DisAssembleI2L(I2LBinary.Code,Disasm);
		I2LDisasmDlg.DisAsmMemo.Text:=Disasm;
		DebugDlg.I2LEditor.Text:=Disasm;
		end;
 	if I2LDisasmDlg.CodeDataChk.Checked then
		begin
		I2LDisasmDlg.CodeMapMemo.Text:=GetDataDump(I2LBinary.Code, not I2LDisasmDlg.DisassembleChk.Checked);
		end;
	end;
end;

procedure TI2LDisasmDlg.FormCreate(Sender: TObject);
begin
PageControl1.ActivePageIndex:=0;
end;



procedure TI2LDisasmDlg.Button1Click(Sender: TObject);
var I2LHexBinary: string;
var I2LBinary: TI2LProgram;
begin
if Form1.SourceEdit.Editor.EditBuffer.Empty then
	begin
	MessageDlg('No Program', mtWarning, [mbOK], 0);
	exit;
	end;
I2LDisasmDlg.I2LMemo.Clear;
InitializeMessages;
try
ChangeDefaultDir(Form1.SourceEdit.CurrentFile);
DoAutoCompile(Form1.SourceEdit.Editor.Text,I2LHexBinary,IDEMessageHandler);
finally
 MessagePostCompile;
 end;
LoadI2LCode(I2LHexBinary,I2LBinary);
DisplayI2L(I2LHexBinary,I2LBinary);
end;

end.
