unit IDEIntrinStateDlg;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, 
  Buttons, ExtCtrls, Grids, ClipBrd, VCLLibrary,DSupport;

type
  TIntrinStateDlg = class(TForm)
    Panel1: TPanel;
    CancelBtn: TButton;
    Panel2: TPanel;
    IntrinGrid: TStringGrid;
    Button1: TButton;
    procedure IntrinGridDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var IntrinStateDlg: TIntrinStateDlg;


procedure ShowIntrinsicStateDlg;

implementation

uses XPLIntrinValidate;

{$R *.dfm}


procedure ShowIntrinsicStateDlg;
begin
IntrinStateDlg.ShowModal;
end;


function GetTypeStr(C: char): string;
begin
case C of
 'I': Result:='int';
 'R': Result:='real';
 'i': Result:='@int';
 'r': Result:='@real';
 'V': Result:='void';
 else Result:='?';
 end;
end;


function GetArgStr(Args: string): string;
var I: integer;
begin
Result:='';
for I:=1 to Length(Args) do
 if I>1 then Result:=Result+','+GetTypeStr(Args[I])
 else Result:=Result+GetTypeStr(Args[I]);
end;




procedure TIntrinStateDlg.IntrinGridDrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
var Inx: integer;
begin
Inx:=ARow-1;
if ARow = 0 then
	begin
	case ACol of
	 0: OwnerDrawItem(IntrinGrid.Canvas,'#', Rect);
	 1: OwnerDrawItem(IntrinGrid.Canvas,'Name', Rect);
	 2: OwnerDrawItem(IntrinGrid.Canvas,'Type Check', Rect);
	 3: OwnerDrawItem(IntrinGrid.Canvas,'Return Type', Rect);
	 4: OwnerDrawItem(IntrinGrid.Canvas,'Arg Types', Rect);
	 end;
	end
else
	begin
	case ACol of
	 0: OwnerDrawInteger(IntrinGrid.Canvas,Inx, Rect);
	 1: OwnerDrawItem(IntrinGrid.Canvas,IntrinsicTable[Inx].Name, Rect);
	 2: OwnerDrawItem(IntrinGrid.Canvas,PickString(IntrinsicTable[Inx].TypeCheck,'Yes','No'), Rect);
	 3: OwnerDrawItem(IntrinGrid.Canvas,GetTypeStr(IntrinsicTable[Inx].ReturnType), Rect);
	 4: OwnerDrawItem(IntrinGrid.Canvas,GetArgStr(IntrinsicTable[Inx].ArgTypes), Rect);
	 end;
	end;

end;



procedure TIntrinStateDlg.Button1Click(Sender: TObject);
var I: integer;
var S: string;
begin
S:='#'+Tab_Char+'Name'+Tab_Char+'Type Check'+Tab_Char+'Return Type'+Tab_Char+'Arg Types'+CRLF_Char;
for I:=0 to High(IntrinsicTable) do
	begin
	S:=S+IntToStr(I);
	S:=S+Tab_Char+IntrinsicTable[I].Name;
	S:=S+Tab_Char+PickString(IntrinsicTable[I].TypeCheck,'Yes','No');
	S:=S+Tab_Char+GetTypeStr(IntrinsicTable[I].ReturnType);
	S:=S+Tab_Char+GetArgStr(IntrinsicTable[I].ArgTypes)+CRLF_Char;
	end;

ClipBoard.Open;
ClipBoard.AsText:=S;

ClipBoard.Close;
end;

end.
