unit IDEIntrinsicList;

interface

uses Windows, Messages, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls,Menus,ScrollEditor,VCLLibrary,DSupport, SpinButtons;

type
  TIntrinsicDlg = class(TForm)
    Panel1: TPanel;
    IntrinsicEdit: TEditEx;
    IntrinsicList: TListBox;
    procedure FormShow(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure IntrinsicListKeyPress(Sender: TObject; var Key: Char);
    procedure IntrinsicEditChange(Sender: TObject);
    procedure IntrinsicEditKeyPress(Sender: TObject; var Key: Char);
    procedure IntrinsicEditDblClick(Sender: TObject);
    procedure IntrinsicEditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var IntrinsicDlg: TIntrinsicDlg;

var IntrinNames: TStringList;


procedure ShowIntrinsicDlg(Editor: TScrollEditor; Pos: TPoint; Text: string);


implementation

uses EBXMain, I2lIntrinsics,CodeEditor;

{$R *.dfm}

var GlobalEditor: TScrollEditor;


procedure ShowIntrinsicDlg(Editor: TScrollEditor; Pos: TPoint; Text: string);
begin
GlobalEditor:=Editor;
IntrinsicDlg.IntrinsicEdit.Text:=Text;
IntrinsicDlg.Left:=Pos.X;
IntrinsicDlg.Top:=Pos.Y;
IntrinsicDlg.Show;
if IntrinsicDlg.IntrinsicEdit.CanFocus then IntrinsicDlg.IntrinsicEdit.SetFocus;
end;



procedure InsertInstrinsic;
var Inx: integer;
var S: string;
begin
with IntrinsicDlg do
 begin
 Inx:=IntrinsicList.ItemIndex;
 if Inx>=0 then S:=GetProtoType(integer(IntrinsicList.Items.Objects[Inx]),True)
 else S:=IntrinsicEdit.Text;
 GlobalEditor.InsertString(S);
 Close;
 end;
end;



procedure TIntrinsicDlg.FormShow(Sender: TObject);
begin
IntrinsicDlg.Caption:=IntToStr(Left)+' '+IntToStr(Top);
end;


procedure TIntrinsicDlg.FormDeactivate(Sender: TObject);
begin
if IntrinsicDlg.Visible then IntrinsicDlg.Close;
end;




procedure TIntrinsicDlg.FormCreate(Sender: TObject);
var SL: TStrings;
begin
IntrinNames:=TStringList.Create;
Application.OnDeactivate:=FormDeactivate;
SL:=IntrinsicList.Items;
GetPrototypeList(SL);
end;



procedure TIntrinsicDlg.FormDestroy(Sender: TObject);
begin
IntrinNames.Free;
end;




procedure TIntrinsicDlg.IntrinsicListKeyPress(Sender: TObject;
  var Key: Char);
begin
case Key of
 CR_Char: InsertInstrinsic;
 ESC_Char: Close;
 end;
end;






procedure TIntrinsicDlg.IntrinsicEditChange(Sender: TObject);
const indexStart = -1;
var S: string;
begin
S:=IntrinsicEdit.Text;
IntrinsicList.ItemIndex := IntrinsicList.Perform(LB_SELECTSTRING, -1, integer(@S[1])) ;
end;


procedure TIntrinsicDlg.IntrinsicEditKeyPress(Sender: TObject;
  var Key: Char);
var Handled: boolean;
begin
Handled:=True;
case Key of
 CR_Char: InsertInstrinsic;
 ESC_Char: Close;
 else Handled:=False;
 end;
if Handled then Key:=#0;
end;




procedure TIntrinsicDlg.IntrinsicEditDblClick(Sender: TObject);
begin
InsertInstrinsic;
end;





procedure TIntrinsicDlg.IntrinsicEditKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
if (Key=VK_DOWN) or (Key=VK_UP) then
	begin
	PostMessage(IntrinsicList.Handle, WM_KEYDOWN , Key, 0);
	Key:=0;
	end;
end;

end.
