unit IDELineNumbers;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, Grids, Dialogs,DSupport, ComCtrls, Clipbrd, ScrollEditor;

type
  TLineNumberDlg = class(TForm)
    Panel1: TPanel;
    CancelBtn: TButton;
    LineNumberList: TListView;
    CopyBtn: TButton;
    BitBtn1: TBitBtn;
    procedure CancelBtnClick(Sender: TObject);
    procedure CopyBtnClick(Sender: TObject);
    procedure LineNumberListDblClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  LineNumberDlg: TLineNumberDlg;

procedure ShowLineNumberDlg;

implementation

uses XPLCompiler, XPLDataTypes, EBXMain, IDECompileMessages, I2LGlobal,
  I2LLoader, I2LDataTypes, IDEGlobal, IDEDebugger,IDEStruncts;

{$R *.dfm}




procedure ShowLineNumbers(Offset: integer);
var I,J: integer;
var PCArray: TPCArray;
var FN: string;
var LI: TListItem;
begin
with LineNumberDlg do
 begin
 LineNumberList.Clear;
 for J:=0 to High(SourceArray) do
	begin
	PCArray:=SourceArray[J].PCArray;
	for I:=0 to High(PCArray) do
		begin
		FN:=ExtractFilename(PCArray[I].Info.Filename);
		LI:=LineNumberList.Items.Add;
		LI.Caption:=IntToStr(I+1);
		LI.SubItems.Add(FN);
		LI.SubItems.Objects[0]:=@PCArray[I].Info;
		LI.SubItems.Add(IntToStr(PCArray[I].Info.Line));
		LI.SubItems.Add(IntToHex(PCArray[I].PC+Offset,IntBytes));
		LI.SubItems.Add(IntToStr(PCArray[I].PC+Offset));
		end;
	end;
 end;
end;



procedure TLineNumberDlg.LineNumberListDblClick(Sender: TObject);
var Info: TSourceInfo;
var P: TPoint;
var ED: TScrollEditor;
begin
Info:=TSourceInfo(Pointer(LineNumberList.Selected.SubItems.Objects[0])^);

SetEditorPosition(Info);
if DebugDlg.Visible then
	begin
	P:=Point(Info.Column,Info.Line);
	ED:=SetDebugEditor(Info.Filename);
	ED.SetCursorPosition(P);
	ED.HighlightRow:=P.Y;
	ED.Invalidate;
	if ED.CanFocus then ED.SetFocus;
	end;
end;



procedure ShowLineNumberDlg;
var ErrCnt: integer;
var I2LCode: string;
var I2LBinary: TI2LProgram;
begin
InitializeMessages;
Form1.MessageView.Items.Clear;
try
ChangeDefaultDir(Form1.SourceEdit.CurrentFile);
ErrCnt:=DoAutoCompile(Form1.SourceEdit.Editor.Text,I2LCode,IDEMessageHandler);
finally MessagePostCompile; end;
if ErrCnt>0 then
	begin
	MessageDlg('Compile Errors, Cannot Debug.',mtWarning, [mbOK], 0);
	exit;
	end;
LoadI2LCode(I2LCode,I2LBinary);
ShowLineNumbers(I2LBinary.BaseAddress);
LineNumberDlg.Show;
end;



procedure TLineNumberDlg.CancelBtnClick(Sender: TObject);
begin
Close;
end;



procedure TLineNumberDlg.CopyBtnClick(Sender: TObject);
var I,J: integer;
var S: string;
var Item: TListItem;
begin
S:='';
for I:=0 to LineNumberList.Items.Count-1 do
	begin
	Item:=LineNumberList.Items[I];
	S:=S+Item.Caption;
	for J:=0 to Item.SubItems.Count-1 do
		begin
		S:=S+'	'+Item.SubItems[J];
		end;
	S:=S+CRLF_Char;
	end;
ClipBoard.Open;
ClipBoard.AsText:=S;
ClipBoard.Close;
end;




end.
