unit IDEModifyVariable;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, 
  Buttons, ExtCtrls, IDEVariables, SpinButtons, intspin, Realspin, ComCtrls,
  Dialogs, IDEVariableLib;

type
  TModifyDlg = class(TForm)
    PageControl1: TPageControl;
    Panel1: TPanel;
    Label1: TLabel;
    ProcDis: TEdit;
    Label4: TLabel;
    LevelDis: TEdit;
    Label2: TLabel;
    VariableDis: TEdit;
    Label5: TLabel;
    OffsetDis: TEdit;
    Label3: TLabel;
    VarTypeDis: TEdit;
    Panel2: TPanel;
    OKBtn: TButton;
    CancelBtn: TButton;
    IntSheet: TTabSheet;
    RealSheet: TTabSheet;
    GroupBox1: TGroupBox;
    Label6: TLabel;
    IntDis: TEdit;
    NewIntSpin: TIntegerSpin;
    Label7: TLabel;
    GroupBox2: TGroupBox;
    Label8: TLabel;
    Label9: TLabel;
    RealDis: TEdit;
    NewRealSpin: TRealSpin;
    CharSheet: TTabSheet;
    GroupBox3: TGroupBox;
    Label10: TLabel;
    Label11: TLabel;
    StringDis: TEdit;
    NewStrEdit: TEdit;
    Label12: TLabel;
    AddressDis: TEdit;
    Panel3: TPanel;
    StatusDis: TPanel;
    IntCharDis: TEdit;
    Label13: TLabel;
    NewIntCharEdit: TEdit;
    Label14: TLabel;
    BitBtn1: TBitBtn;
    procedure NewIntSpinChange(Sender: TObject);
    procedure NewIntCharEditChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ModifyDlg: TModifyDlg;

procedure DoModifyVariable(var VI: TVariableInfo; VF: TVarFormat);

implementation

uses I2LInterp, XPLDataTypes, IDEBitmapDlg;



{$R *.dfm}

var VarAdd: integer;		{Absolute address of the variable}
var DisplayType: TDisplayType;	{Display type of the variable}
var CurFormat: TVarFormat;	{Format of the current variable}

function GetVarTypeStr(VT: TVariableType): string;
begin
case VT of
 vtInteger: Result:='Integer';
 vtChar: Result:='Char';
 vtReal: Result:='Real';
 vtRealConst: Result:='Real';
 vtIntConst: Result:='Int Const';
 end;
end;



procedure DisplayVariable(var WF: TVariableInfo);
var I: integer;
var R: double;
var S: string;
begin
case DisplayType of
 dsCharString:
	begin
	ModifyDlg.PageControl1.ActivePage:=ModifyDlg.CharSheet;
	if I2LProgram.RangeCheck(VarAdd) then
		begin
		S:=char(I2LProgram.DataByte[VarAdd]);
		ModifyDlg.StringDis.Text:=S;
		ModifyDlg.NewStrEdit.Text:=S;
		ModifyDlg.NewStrEdit.MaxLength:=Length(S);
                ModifyDlg.StatusDis.Caption:='';
		end
	else ModifyDlg.StatusDis.Caption:='Access Error';
	end;
 dsString:
	begin
	ModifyDlg.PageControl1.ActivePage:=ModifyDlg.CharSheet;
	if I2LProgram.RangeCheck(VarAdd) and
	   I2LProgram.RangeCheck(I2LProgram.GetDataWord(VarAdd)) then
		begin
		S:=I2LProgram.GetDataString(I2LProgram.GetDataWord(VarAdd),UseMSBStrings);
		ModifyDlg.StringDis.Text:=S;
		ModifyDlg.NewStrEdit.Text:=S;
		ModifyDlg.NewStrEdit.MaxLength:=Length(S);
                ModifyDlg.StatusDis.Caption:='';
		end
	else ModifyDlg.StatusDis.Caption:='Access Error';
	end;
 dsInteger:
	begin
	ModifyDlg.PageControl1.ActivePage:=ModifyDlg.IntSheet;
	if I2LProgram.RangeCheck(VarAdd) then
		begin
		I:=I2LProgram.GetDataWord(VarAdd);
		ModifyDlg.NewIntSpin.Value:=I;
		ModifyDlg.IntDis.Text:=IntToStr(I);
                ModifyDlg.StatusDis.Caption:='';
		end
	else ModifyDlg.StatusDis.Caption:='Access Error';
	end;
 dsByte:
	begin
	ModifyDlg.PageControl1.ActivePage:=ModifyDlg.IntSheet;
	if I2LProgram.RangeCheck(VarAdd) then
		begin
		I:=I2LProgram.DataByte[VarAdd];
		ModifyDlg.NewIntSpin.Value:=I;
		ModifyDlg.IntDis.Text:=IntToStr(I);
                ModifyDlg.StatusDis.Caption:='';
		end
	else ModifyDlg.StatusDis.Caption:='Access Error';
	end;
 dsReal:
	begin
	ModifyDlg.PageControl1.ActivePage:=ModifyDlg.RealSheet;
	if I2LProgram.RangeCheck(VarAdd) then
		begin
		R:=I2LProgram.GetDataDouble(VarAdd);
		ModifyDlg.NewRealSpin.Value:=R;
		ModifyDlg.RealDis.Text:=FloatToStrF(R,ffFixed,18,CurFormat.Digits);
                ModifyDlg.StatusDis.Caption:='';
		end
	else ModifyDlg.StatusDis.Caption:='Access Error';
	end;
 end;
end;



procedure SetVariable(var VI: TVariableInfo);
var Accessible: boolean;
var S: string;
begin
case DisplayType of
 dsCharString:
	begin
	accessible:=I2LProgram.RangeCheck(VarAdd);
	if Accessible then
		begin
		S:=ModifyDlg.NewStrEdit.Text;
		if Length(S)>0 then I2LProgram.DataByte[VarAdd]:=byte(S[1]);
		end;
	end;
 dsString:
	begin
	accessible:=I2LProgram.RangeCheck(VarAdd) and I2LProgram.RangeCheck(I2LProgram.GetDataWord(VarAdd));
	if accessible then I2LProgram.SetDataString(ModifyDlg.NewStrEdit.Text,I2LProgram.GetDataWord(VarAdd));
	end;
 dsInteger:
	begin
	accessible:=I2LProgram.RangeCheck(VarAdd);
	if accessible then I2LProgram.SetDataWord(VarAdd,ModifyDlg.NewIntSpin.Value);
	end;
 dsByte:
	begin
	accessible:=I2LProgram.RangeCheck(VarAdd);
	if accessible then I2LProgram.DataByte[VarAdd]:=ModifyDlg.NewIntSpin.Value;
	end;
 dsReal:
	begin
	accessible:=I2LProgram.RangeCheck(VarAdd);
	if accessible then I2LProgram.SetDataDouble(VarAdd,ModifyDlg.NewRealSpin.Value);
	end;
 end;
if not accessible then MessageDlg('Cannot modify - Inaccessibe.',mtWarning, [mbOK], 0);
end;


function ValidateVariable(VI: TVariableInfo; var ErrorMsg: string): boolean;
var Status: TVarStatus;
begin
ErrorMsg:='';
if (VI.VarType=vtRealConst) or (VI.VarType=vtIntConst) then ErrorMsg:='Cannot Modify Constants'
else
	begin
	Status:=GetVariableAddress(VI,VarAdd);
	case Status of
	 vsScopeError: ErrorMsg:='Out of Scope';
	 vsAccessError: ErrorMsg:='Access Error';
	 end;
	end;
Result:=ErrorMsg='';
end;





procedure DoModifyVariable(var VI: TVariableInfo; VF: TVarFormat);
var ErrorMsg: string;
begin
if not ValidateVariable(VI,ErrorMsg) then
	begin
	MessageDlg(ErrorMsg,mtWarning, [mbOK], 0);
	Exit;
	end;
ModifyDlg.ProcDis.Text:=VI.ProcName;
ModifyDlg.VariableDis.Text:=VI.BaseName+GetIndicesString(VI);
ModifyDlg.VarTypeDis.Text:=GetVarTypeStr(VI.VarType);
ModifyDlg.LevelDis.Text:=IntToStr(VI.Level);
ModifyDlg.OffsetDis.Text:=IntToStr(VI.Offset);
ModifyDlg.AddressDis.Text:='$'+IntToHex(VarAdd,IntNibbles);

CurFormat:=VF;
DisplayType:=VF.DisplayType;
DisplayVariable(VI);
ModifyDlg.ShowModal;
if ModifyDlg.ModalResult=mrOK then
	begin
	SetVariable(VI);
	UpdateBitmapDisplay(VI);
	end;
end;

var SpinUpdate: boolean;

procedure TModifyDlg.NewIntSpinChange(Sender: TObject);
begin
SpinUpdate:=True;
NewIntCharEdit.Text:=Char(NewIntSpin.Value and $FF);
SpinUpdate:=False;
end;

procedure TModifyDlg.NewIntCharEditChange(Sender: TObject);
var S: string;
begin
if SpinUpdate then exit;
S:=NewIntCharEdit.Text;
if Length(S)>0 then NewIntSpin.NoEventValue:=Integer(S[1])
else NewIntSpin.NoEventValue:=0;
end;

end.
