unit IDERunParams;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, 
  Buttons, ExtCtrls, Grids, DSupport;

type
  TRuntimeDlg = class(TForm)
    Panel1: TPanel;
    CancelBtn: TButton;
    Panel2: TPanel;
    Panel3: TPanel;
    UseComChk: TCheckBox;
    ClearBtn: TButton;
    Label1: TLabel;
    ComLineGrid: TStringGrid;
    BitBtn1: TBitBtn;
    procedure ClearBtnClick(Sender: TObject);
    procedure UseComChkClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  RuntimeDlg: TRuntimeDlg;

procedure ShowRuntimeDlg;

implementation

uses I2lIntrinsics,IniFiles, IDEGlobal;

{$R *.dfm}



procedure SaveRuntimeDefaults;
{Save current macro to INI}
var IDEIni: TIniFile;
var I: integer;
var GS: TStrings;
const Section='CommandLine';
begin
GS:=RuntimeDlg.ComLineGrid.Cols[1];
IDEIni:=TIniFile.Create(IDEIniFilename);
IDEIni.EraseSection(Section);
for I:=1 to GS.Count-1 do
	EncodeINIString(IDEIni,Section,'Arg'+IntToStr(I-1),GS[I]);
IDEIni.WriteInteger(Section,'Count',GS.Count-1);
IDEIni.Free;
end;




procedure GetRuntimeDefaults;
{Restore current macro }
var IDEIni: TIniFile;
var I,Count: integer;
var S: string;
const Section='CommandLine';
begin
IDEIni:=TIniFile.Create(IDEIniFilename);
Count:=IDEIni.ReadInteger(Section,'Count',0);
for I:=0 to Count-1 do
	begin
	S:=DecodeINIString(IDEIni,Section,'Arg'+IntToStr(I),'');
	RuntimeDlg.ComLineGrid.Cells[1,I+1]:=S;
	end;
IDEIni.Free;
end;




procedure SetUserComLineArgs;
var SL: TStringList;
var GS: TStrings;
var I: integer;
begin
SL:=TStringList.Create;
try
SL.Add(ParamStr(0));
GS:=RuntimeDlg.ComLineGrid.Cols[1];
for I:=1 to GS.Count-1 do
 if GS[I]<>'' then SL.Add(GS[I]);
SetCommandLine(SL);
finally SL.Free; end;
end;



procedure TRuntimeDlg.ClearBtnClick(Sender: TObject);
begin
ComLineGrid.Cols[1].Clear;
RuntimeDlg.ComLineGrid.Cells[1,0]:='Command Line Arguments';
end;



procedure TRuntimeDlg.UseComChkClick(Sender: TObject);
begin
if UseComChk.Checked then SetUserComLineArgs
else GetWinCommandLine;
end;



procedure ShowRuntimeDlg;
begin
RunTimeDlg.ShowModal;
RuntimeDlg.UseComChkClick(RunTimeDlg);
end;


procedure TRuntimeDlg.FormCreate(Sender: TObject);
var I: integer;
begin
RuntimeDlg.ComLineGrid.Cells[0,0]:='#';
RuntimeDlg.ComLineGrid.Cells[1,0]:='Command Line Arguments';
for I:=1 to RuntimeDlg.ComLineGrid.RowCount-1 do
	RuntimeDlg.ComLineGrid.Cells[0,I]:=IntToStr(I);
GetRuntimeDefaults;
end;




procedure TRuntimeDlg.FormDestroy(Sender: TObject);
begin
SaveRuntimeDefaults;
end;

end.
