unit IDEStackDump;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, 
  Buttons, ExtCtrls, ComCtrls, ScrollEditor;

type
  TStackDumpDlg = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    StackList: TListView;
    Panel3: TPanel;
    CancelBtn: TButton;
    InfoDis: TPanel;
    BitBtn1: TBitBtn;
    procedure CancelBtnClick(Sender: TObject);
    procedure StackListDblClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var StackDumpDlg: TStackDumpDlg;

procedure ShowStackDump;
procedure UpdateStackDump;

implementation

uses I2LGlobal, XPLDataTypes, XPLCompiler, EBXMain, IDEDebugger, IDEGlobal;

{$R *.dfm}




procedure FindLineNumbers;
var I: integer;
var Info: TPCInfo;
begin
for I:=0 to High(StackDump) do
	begin
	Info:=PCToSourceData(StackDump[I].Address,ProgramStore.ProgData.BaseAddress);
	StackDump[I].Line:=Info.Info.Line;
	StackDump[I].Column:=Info.Info.Column;
	AddressToProcName(StackDump[I].Address,StackDump[I].Filename,StackDump[I].ProcName);
	end;
end;




procedure FillStackList;
var I: integer;
var ListItem: TListItem;
begin
StackDumpDlg.StackList.Clear;
for I:=0 to High(StackDump) do
	begin
	ListItem:=StackDumpDlg.StackList.Items.Add;
	ListItem.Caption:=IntToStr(I);
	ListItem.SubItems.Add(ExtractFilename(StackDump[I].Filename));
	ListItem.SubItems.Add(StackDump[I].Procname);
	ListItem.SubItems.Add(IntToHex(StackDump[I].Address,IntNibbles));
	ListItem.SubItems.Add(IntToStr(StackDump[I].Line));
	end;
end;


procedure UpdateStackDump;
begin
if not StackDumpDlg.Visible then exit;
GetStackDump(StackDump);
FindLineNumbers;
FillStackList;
StackDumpDlg.InfoDis.Caption:='Stack Entries Count: '+IntToStr(Length(StackDump));
end;



procedure ShowStackDump;
begin
StackDumpDlg.Show;
UpdateStackDump;
end;


procedure TStackDumpDlg.CancelBtnClick(Sender: TObject);
begin
Close;
end;


procedure TStackDumpDlg.StackListDblClick(Sender: TObject);
var Inx: integer;
var SD: TStackItem;
var PCInfo: TPCInfo;
var P: TPoint;
var ED: TScrollEditor;
begin
Inx:=StackList.Selected.Index;
SD:=StackDump[Inx];
PCInfo:=PCToSourceData(SD.Address,ProgramStore.ProgData.BaseAddress);
SetEditorPosition(PCInfo.Info);

if DebugDlg.Visible then
	begin
	P:=Point(PCInfo.Info.Column,PCInfo.Info.Line);
	ED:=SetDebugEditor(PCInfo.Info.Filename);
	ED.SetCursorPosition(P);
	ED.HighlightRow:=P.Y;
	ED.Invalidate;
	if ED.CanFocus then ED.SetFocus;
	end;
end;



end.
