unit IDEStruncts;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, ImgList, ComCtrls, TreeViewEx, XPLCompiler, Grids, VCLLibrary;

type
  TStructsDlg = class(TForm)
    Panel1: TPanel;
    CancelBtn: TButton;
    Panel2: TPanel;
    ImageList1: TImageList;
    StructGrid: TStringGrid;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  StructsDlg: TStructsDlg;

procedure ShowStructsDlg;
procedure HandleCompilerEvents(Info: TCompEventType; ProcName: string);

implementation

{$R *.dfm}

uses XPLStructs, IDEDebugger, IDEGlobal;

var CurRow: integer;

function GetRowCount: integer;
var I: integer;
begin
Result:=0;
for I:=0 to UserTypeIndex-1 do
	begin
	Inc(Result,SubitemCount[I]);
	end;
end;


procedure ShowStructTables(Grid: TStringGrid; ProcName: string);
var I,J,Inx: integer;
begin
Inx:=0;
Grid.RowCount:=Grid.RowCount+GetRowCount;
Grid.Cells[0,0]:='#';
Grid.Cells[1,0]:='Procedure';
Grid.Cells[2,0]:='UserTypeNames';
Grid.Cells[3,0]:='SubitemCount';
Grid.Cells[4,0]:='SubitemIndices';
Grid.Cells[5,0]:='Subitem Index';
Grid.Cells[6,0]:='SubitemName';
Grid.Cells[7,0]:='SubitemType';
Grid.Cells[8,0]:='SubUserIndex';
for I:=0 to UserTypeIndex-1 do
	begin
	Grid.Cells[0,CurRow]:=IntToStr(I);
	Grid.Cells[1,CurRow]:=ProcName;
	Grid.Cells[2,CurRow]:=UserTypeNames[I];
	Grid.Cells[3,CurRow]:=IntToStr(SubitemCount[I]);
	Grid.Cells[4,CurRow]:=IntToStr(SubitemIndices[I]);
	for J:=0 to SubitemCount[I]-1 do
		begin
                Grid.Cells[5,CurRow+J]:=IntToStr(Inx+J);
                Grid.Cells[6,CurRow+J]:=SubitemName[Inx+J];
                Grid.Cells[7,CurRow+J]:=IntToStr(SubitemType[Inx+J]);
                Grid.Cells[8,CurRow+J]:=IntToStr(SubUserIndex[Inx+J]);
		end;
	Inc(Inx,SubitemCount[I]);
	Inc(CurRow,SubitemCount[I]);
	end;

end;


procedure ResetGrid;
begin
{Clear grid before changing row count}
ClearStringGrid(StructsDlg.StructGrid,True);
StructsDlg.StructGrid.RowCount:=2;
CurRow:=1;
end;




procedure HandleCompilerEvents(Info: TCompEventType; ProcName: string);
begin
case Info of
 etCompileStart: ResetGrid;
 etAfterVarDec: ShowStructTables(StructsDlg.StructGrid, ProcName);
 etCompileEnd: if StructsDlg.StructGrid.RowCount<25 then StructsDlg.StructGrid.RowCount:=25;
 end;
end;



procedure ShowStructsDlg;
begin
if not DoCompileOnly then exit;
StructsDlg.Show;
end;



end.
