unit IDESymbolDump;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, 
  Buttons, ExtCtrls;

type
  TDumpDlg = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    DumpMemo: TMemo;
    DumpRadio: TRadioGroup;
    Button1: TButton;
    procedure DumpRadioClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DumpDlg: TDumpDlg;


procedure ShowSymbolDump;

implementation

uses XPLCompiler;

{$R *.dfm}


procedure DumpSymbols;
var Proc: TProcItem;
var Item: TSymbolItem;
var I,J: integer;
begin
with DumpDlg do
 begin
 DumpMemo.Clear;
 for I:=0 to High(SymbolDump) do
	begin
	Proc:=SymbolDump[I];
	DumpMemo.Lines.Add(Proc.ProcName);
	for J:=0 to High(Proc.Symbols) do
		begin
		Item:=Proc.Symbols[J];
		DumpMemo.Lines.Add('   '+Item.Name);
		end;
	end;
 end;
end;


procedure DumpListing;
begin
with DumpDlg do
 begin
 DumpMemo.Clear;
 DumpMemo.Text:=ListText;
 end;
end;


procedure DumpIncludes;
var I: integer;
begin
with DumpDlg do
 begin
 DumpMemo.Clear;
 for I:=0 to High(SourceArray) do
	begin
	DumpMemo.Lines.Add('   '+SourceArray[I].Info.Filename);
	end;
 end;
end;



procedure DumpItems;
begin
case DumpDlg.DumpRadio.ItemIndex of
 0: DumpSymbols;
 1: DumpListing;
 2: DumpIncludes;
 end;
end;



procedure ShowSymbolDump;
begin
with DumpDlg do
 begin
 DumpItems;
 Show;
 end;
end;



procedure TDumpDlg.DumpRadioClick(Sender: TObject);
begin
DumpItems;
end;

procedure TDumpDlg.Button1Click(Sender: TObject);
begin
DumpDlg.Close;
end;

end.
