unit IDEVariableDis;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, 
  Buttons, ExtCtrls, SpinButtons, intspin;

type
  TExpandedDisDlg = class(TForm)
    Panel1: TPanel;
    CancelBtn: TButton;
    Panel2: TPanel;
    Label1: TLabel;
    VarMemo: TMemo;
    VarInfoDis: TEditEx;
    StartSpin: TIntegerSpin;
    Label2: TLabel;
    ResetBtn: TButton;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure StartSpinChange(Sender: TObject);
    procedure ResetBtnClick(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ExpandedDisDlg: TExpandedDisDlg;

procedure UpdateVariableDisplay;


implementation

uses IDEDebugger,IDEVariableLib;

{$R *.dfm}





function GetVariableInfo(Inx: integer): string;
{Get watch item Description}
var WI: TWatchInfo;
var VI: TVariableInfo;
var R: TLookupResult;
var Format: TVarFormat;
var I: integer;
begin
WI:=WatchArray[Inx];
R:=LookupVariable(WI.VarText,WI.Filename,WI.Line,VI);
if WI.CustomFormat then Format:=WI.UserFormat else Format:=VI.DefFormat;

Result:='Variable: '+WI.VarText;
if VI.HasIndices or Format.ForcedArray then
	begin
	Result:=Result+' Dims: (';
	for I:=0 to High(Format.DisplayDims) do
		begin
		Result:=Result+IntToStr(Format.DisplayDims[I]);
		if I<>High(Format.DisplayDims) then Result:=Result+',';
		end;
	Result:=Result+')';
	end;
if R<>lrFound then Result:=Result+' - (Not Defined)';
end;



procedure UpdateVariableDisplay;
var Inx: integer;
begin
Inx:=DebugDlg.WatchGrid.Row-1;
if Inx>High(WatchArray) then exit;
if Inx<0 then Inx:=0;
if ExpandedDisDlg.Visible then
	begin
	TravStart:=ExpandedDisDlg.StartSpin.Value;
	ExpandedDisDlg.VarInfoDis.Text:=GetVariableInfo(Inx);
	ExpandedDisDlg.VarMemo.Lines.Text:=GetWatchValue(Inx);
	end;
end;



procedure TExpandedDisDlg.FormShow(Sender: TObject);
begin
UpdateVariableDisplay;
end;



procedure TExpandedDisDlg.FormCreate(Sender: TObject);
begin
Panel2.DoubleBuffered:=True;
end;


procedure TExpandedDisDlg.StartSpinChange(Sender: TObject);
begin
UpdateVariableDisplay;
end;

procedure TExpandedDisDlg.ResetBtnClick(Sender: TObject);
begin
StartSpin.Value:=0;
end;

procedure TExpandedDisDlg.CancelBtnClick(Sender: TObject);
begin
Close;
end;

end.
