unit IDEWatchFormat;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, 
  Buttons, ExtCtrls, IDEVariables, SpinButtons, intspin,VCLLibrary,
  ComCtrls,IDEVariableLib, CheckedGroup, DSupport;

type
  TFormatDlg = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Panel1: TPanel;
    CancelBtn: TButton;
    ApplyBtn: TButton;
    Label1: TLabel;
    ProcDis: TEdit;
    Label12: TLabel;
    AddressDis: TEdit;
    Label7: TLabel;
    LevelDis: TEdit;
    Label8: TLabel;
    OffsetDis: TEdit;
    Label9: TLabel;
    ScopeDis: TEdit;
    CustomFormatChk: TCheckedGroup;
    RadixRadio: TRadioGroup;
    Label4: TLabel;
    DigitsSpin: TIntegerSpin;
    DisplayRadio: TRadioGroup;
    StaticText1: TStaticText;
    VariableDis: TEdit;
    StaticText2: TStaticText;
    VarTypeDis: TEdit;
    ExpressCombo: TComboBox;
    Label2: TLabel;
    BitBtn1: TBitBtn;
    RealFormatRadio: TRadioGroup;
    ArrayChk: TCheckedGroup;
    Panel2: TPanel;
    Label3: TLabel;
    DimSpin: TIntegerSpin;
    Panel3: TPanel;
    Label5: TLabel;
    ScrollBox1: TScrollBox;
    InxPan1: TPanel;
    DimSizeSpin1: TIntegerSpin;
    Panel4: TPanel;
    InxPan4: TPanel;
    DimSizeSpin4: TIntegerSpin;
    Panel5: TPanel;
    InxPan8: TPanel;
    DimSizeSpin8: TIntegerSpin;
    Panel6: TPanel;
    InxPan7: TPanel;
    DimSizeSpin7: TIntegerSpin;
    Panel8: TPanel;
    InxPan6: TPanel;
    DimSizeSpin6: TIntegerSpin;
    Panel10: TPanel;
    InxPan5: TPanel;
    DimSizeSpin5: TIntegerSpin;
    Panel12: TPanel;
    InxPan3: TPanel;
    DimSizeSpin3: TIntegerSpin;
    Panel14: TPanel;
    InxPan2: TPanel;
    DimSizeSpin2: TIntegerSpin;
    Panel18: TPanel;
    InxPan9: TPanel;
    DimSizeSpin9: TIntegerSpin;
    Panel20: TPanel;
    InxPan10: TPanel;
    DimSizeSpin10: TIntegerSpin;
    Panel16: TPanel;
    procedure ApplyBtnClick(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure DimSpinChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormatDlg: TFormatDlg;

procedure DoWatchFormat(var WI: TWatchInfo);

implementation

uses IDEDebugger, I2LInterp, XPLDataTypes, IDEBitmapDlg, IDEGlobal;

{$R *.dfm}

var ValidVariable: boolean;

var VariableInfo: TVariableInfo;

var WatchInfo: ^TWatchInfo;


{Routines to handle array dimensions}

function GetVarTypeStr(VT: TVariableType): string;
begin
case VT of
 vtInteger: Result:='Integer';
 vtChar: Result:='Char';
 vtReal: Result:='Real';
 vtRealConst: Result:='Real';
 vtIntConst: Result:='Int Const';
 end;
end;


procedure ShowDimSizeSpins(Dims: integer);
begin
with FormatDlg do
 begin
 InxPan10.Visible:=Dims>=10;
 InxPan9.Visible:=Dims>=9;
 InxPan8.Visible:=Dims>=8;
 InxPan7.Visible:=Dims>=7;
 InxPan6.Visible:=Dims>=6;
 InxPan5.Visible:=Dims>=5;
 InxPan4.Visible:=Dims>=4;
 InxPan3.Visible:=Dims>=3;
 InxPan2.Visible:=Dims>=2;
 InxPan1.Visible:=Dims>=1;
 end;
end;


function GetDimSizeSpin(Dim: integer): TIntegerSpin;
begin
case Dim of
 0: Result:=FormatDlg.DimSizeSpin1;
 1: Result:=FormatDlg.DimSizeSpin2;
 2: Result:=FormatDlg.DimSizeSpin3;
 3: Result:=FormatDlg.DimSizeSpin4;
 4: Result:=FormatDlg.DimSizeSpin5;
 5: Result:=FormatDlg.DimSizeSpin6;
 6: Result:=FormatDlg.DimSizeSpin7;
 7: Result:=FormatDlg.DimSizeSpin8;
 8: Result:=FormatDlg.DimSizeSpin9;
 9: Result:=FormatDlg.DimSizeSpin10;
 else Result:=nil;
 end;
end;





procedure GetArrayDims(var Format: TVarFormat);
var I: integer;
begin
with FormatDlg do
 begin
 WatchInfo.UserFormat.ForcedArray:=ArrayChk.Checked;
 SetLength(Format.DisplayDims,DimSpin.Value);
 for I:=0 to High(Format.DisplayDims) do Format.DisplayDims[I]:=GetDimSizeSpin(I).Value;
 end;
end;


procedure SetArrayDims(Format: TVarFormat);
var I: integer;
begin
with FormatDlg do
 begin
 ArrayChk.Checked:=WatchInfo.UserFormat.ForcedArray;
 DimSpin.Value:=Length(Format.DisplayDims);
 for I:=0 to High(Format.DisplayDims) do GetDimSizeSpin(I).Value:=Format.DisplayDims[I];
 end;
end;


procedure ShowVariableData;
var Add,Ind: integer;
const S = 'Lookup Failure';
begin
with FormatDlg do
 begin
 if ValidVariable then
	begin
	VariableDis.Text:=VariableInfo.BaseName+GetIndicesString(VariableInfo);
	VarTypeDis.Text:=GetVarTypeStr(VariableInfo.VarType);
	ProcDis.Text:=VariableInfo.ProcName;
	LevelDis.Text:=IntToStr(VariableInfo.Level);
	OffsetDis.Text:=IntToStr(VariableInfo.Offset);
	Add:=DisplayVector[VariableInfo.Level]+VariableInfo.Offset;
	Ind:=I2LProgram.GetDataWord(Add);
	AddressDis.Text:='$'+IntToHex(Add,IntNibbles);
	ScopeDis.Text:='$'+IntToHex(VariableInfo.BeginPC,SizeOf(TI2LWord)*2)+
 		   ' $'+IntToHex(VariableInfo.EndPC,SizeOf(TI2LWord)*2);
 	end
 else
	begin
	VariableDis.Text:=S;
	VarTypeDis.Text:=S;
	ProcDis.Text:=S;
	LevelDis.Text:=S;
	OffsetDis.Text:=S;
	AddressDis.Text:=S;
	ScopeDis.Text:=S;
 	end;
 end;
end;



function IndexToDisplayType(Inx: integer): TDisplayType;
begin
case Inx of
 0: Result:=dsInteger;
 1: Result:=dsByte;
 2: Result:=dsCharString;
 3: Result:=dsString;
 4: Result:=dsReal;
 end;
end;


function DisplayTypeToIndex(DT: TDisplayType): integer;
begin
case DT of
 dsInteger: Result:=0;
 dsByte: Result:=1;
 dsCharString: Result:=2;
 dsString: Result:=3;
 dsReal: Result:=4;
 end;
end;




procedure GetWatchFormatInfo;
begin
with FormatDlg do
 begin
 ShowVariableData;
 ExpressCombo.Text:=WatchInfo.VarText;
 CustomFormatChk.Checked:=WatchInfo.CustomFormat;
 DisplayRadio.ItemIndex:=DisplayTypeToIndex(WatchInfo.UserFormat.DisplayType);
 DigitsSpin.Value:=WatchInfo.UserFormat.Digits;
 RadixRadio.ItemIndex:=Integer(WatchInfo.UserFormat.Radix);
 RealFormatRadio.ItemIndex:=Integer(WatchInfo.UserFormat.RealFormat);
 SetArrayDims(WatchInfo.UserFormat);
 end;
end;







procedure SetWatchFormatInfo;
begin
with FormatDlg do
 begin
 WatchInfo.VarText:=ExpressCombo.Text;
 WatchInfo.CustomFormat:=CustomFormatChk.Checked;
 WatchInfo.UserFormat.DisplayType:=IndexToDisplayType(DisplayRadio.ItemIndex);
 WatchInfo.UserFormat.Digits:= DigitsSpin.Value;
 WatchInfo.UserFormat.Radix:=TIntegerFormat(RadixRadio.ItemIndex);
 WatchInfo.UserFormat.RealFormat:=TRealFormat(RealFormatRadio.ItemIndex);
 GetArrayDims(WatchInfo.UserFormat);
 UpdateWatchGrid;
 UpdateAndSaveComboBox(IDEIniFilename,'Expressions',FormatDlg.ExpressCombo);
 end;
end;


procedure GetVariableInfo(WI: TWatchInfo);
begin
ValidVariable:=LookupVariable(WI.VarText,WI.Filename,WI.Line,VariableInfo)=lrFound;
end;



procedure DoWatchFormat(var WI: TWatchInfo);
begin
WatchInfo:=@WI;
GetVariableInfo(WI);
GetWatchFormatInfo;
FormatDlg.Show;
end;



procedure TFormatDlg.ApplyBtnClick(Sender: TObject);
begin
SetWatchFormatInfo;
GetVariableInfo(WatchInfo^);
GetWatchFormatInfo;
end;



procedure TFormatDlg.CancelBtnClick(Sender: TObject);
begin
SetWatchFormatInfo;
Close;
end;

procedure TFormatDlg.FormCreate(Sender: TObject);
begin
LoadStringsIni(IDEIniFilename,'Expressions',FormatDlg.ExpressCombo.Items);
PageControl1.ActivePageIndex:=0;
DimSpinChange(Sender);
end;

procedure TFormatDlg.DimSpinChange(Sender: TObject);
begin
ShowDimSizeSpins(DimSpin.Value);
end;

end.
