unit XRTGlobal;

interface

uses Math;

function GetNextValue(V: double): double;
function GetPreviousValue(V: double): double;


implementation

{Routines to handle console scaling parameter}

const ScaleFactors: array [0..24] of double =
      (0.25, 0.30, 0.35, 0.40, 0.45, 0.50, 0.55, 0.60,
       0.65, 0.70, 0.75, 0.80, 0.85, 0.90, 0.95, 1.00,
       1.10, 1.25, 1.50, 1.75, 2.00, 2.50, 3.00, 4.00, 5.00);


function FindNearest(V: double): integer;
var I: integer;
var N: double;
begin
Result:=0;
N:=MaxDouble;
for I:=0 to High(ScaleFactors) do
 if abs(ScaleFactors[I]-V)<N then
	begin
	N:=abs(ScaleFactors[I]-V);
	Result:=I;
	end;
end;



function GetNextValue(V: double): double;
var Inx: integer;
begin
Inx:=FindNearest(V);
if Inx<High(ScaleFactors) then Inc(Inx);
Result:=ScaleFactors[Inx];
end;


function GetPreviousValue(V: double): double;
var Inx: integer;
begin
Inx:=FindNearest(V);
if Inx>0 then Dec(Inx);
Result:=ScaleFactors[Inx];
end;


end.
